// PgTweaks.cpp : implementation file
//

#include "stdafx.h"
#include "emule.h"
#include "PPgMaella.h"
#include "preferences.h"
#include "PreferencesDlg.h"
#include "HttpDownloadDlg.h"
#include "BandwidthControl.h"
#include "opcodes.h"
#include "emuledlg.h"
#include "statisticsdlg.h"
#include "ipfilter.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

// Language definitions
// Don't use the rc file to avoid the nightmare of the merging
enum EMaellaStringID { IDS_PPG_MAELLA_COMPENSATEOVERHEAD,
					   IDS_PPG_MAELLA_MIN_SLOT_STATIC,
					   IDS_PPG_MAELLA_MTU_STATIC,
					   IDS_PPG_MAELLA_SND_SOCKET_SIZE_STATIC,
					   IDS_PPG_MAELLA_NAFC_STATIC01,
					   IDS_PPG_MAELLA_NAFC_STATIC02,
					   IDS_PPG_MAELLA_NAFC_CHECK01,
					   IDS_PPG_MAELLA_NAFC_CHECK02,
					   IDS_PPG_MAELLA_CONNECTION_STATIC,
					   IDS_PPG_MAELLA_XS_CHECK,
					   IDS_PPG_MAELLA_CORRUPTION_STATIC,
					   IDS_PPG_MAELLA_CORRUPTION_CHECK,
					   IDS_PPG_MAELLA_SKIP_CORRUPTION_CD_CHECK,
					   IDS_PPG_MAELLA_IPFILTER_STATIC,
					   IDS_PPG_MAELLA_IPFILTER_VERSION_STATIC,
					   IDS_PPG_MAELLA_UPDATE_IPFILTER_BUTTON,
					   IDS_PPG_MAELLA_FILTER_STATIC,
					   IDS_PPG_MAELLA_FILTER_CHECK01,
					   
					   
					   IDS_PPG_MAELLA_FILTER_CHECK04,
					   IDS_PPG_MAELLA_FILTER_CHECK05,
					   IDS_PPG_MAELLA_FILTER_CHECK06,
					   IDS_PPG_MAELLA_FILTER_CHECK07,
					   IDS_PPG_MAELLA_FILTER_CHECK08,
					   IDS_PPG_MAELLA_FILTER_CHECK09, // [TPT] - Filter own messages
					   IDS_PPG_MAELLA_FILTER_CHECK10, // [TPT] - Filter Handshake messages
					   IDS_PPG_MAELLA_SAMPLERATE_STATIC01,
					   IDS_PPG_MAELLA_SAMPLERATE_STATIC02a,
					   IDS_PPG_MAELLA_SAMPLERATE_STATIC02b,
					   IDS_PPG_MAELLA_ZOOM_STATIC01,
					   IDS_PPG_MAELLA_ZOOM_STATIC02,
					   IDS_PPG_MAELLA_MINIDUMP_STATIC,
					   IDS_PPG_MAELLA_MULTI_QUEUE_STATIC,
					   IDS_PPG_MAELLA_MULTI_QUEUE_CHECK01,
					   IDS_PPG_MAELLA_MULTI_QUEUE_CHECK02,
                       IDS_PPG_MAELLA_NUSS_CHECK01,
					   IDS_PPG_MAELLA_A4AF_STATIC,
					   IDS_PPG_MAELLA_A4AF_CHECK,
					   IDS_PPG_MAELLA_REASK_SOURCE_AFTER_IP_CHANGE_CHECK,
					   IDS_PPG_PHOENIX_SNAFU,
					   IDS_PPG_PHOENIX_ACT,
					   IDS_PPG_PHOENIX_FRIENDSHARE,
					   IDS_PPG_SNAFUGROUP,
					   IDS_PPG_PHOENIX_CUMULATEBW,
					   IDS_PPG_PHOENIX_URLFORUPDATE
};

const TCHAR* GetMaellaResString(EMaellaStringID ID){
	// Here it is the place to add support for other languages
	DWORD primLang = PRIMARYLANGID(thePrefs.GetLanguageID());
	DWORD subLang = SUBLANGID(thePrefs.GetLanguageID());
	switch(primLang){
		case LANG_GERMAN:
			switch(ID){
				case IDS_PPG_MAELLA_COMPENSATEOVERHEAD:					return _T("bernehme Bandbreiten-Limit fr Overhead+Daten");
				case IDS_PPG_MAELLA_MTU_STATIC:							return _T("MTU (Einstellbar 200-1500, Standartwert 1340)");
				case IDS_PPG_MAELLA_MIN_SLOT_STATIC:					return _T("Minimiere Uploadslots (Werte von 2 bis 4, Standart 3)");
				case IDS_PPG_MAELLA_SND_SOCKET_SIZE_STATIC:				return _T("Sende Blockgrsse (Bereich %u..8192, Standartwert 8192)");
				//case IDS_PPG_MAELLA_NAFC_STATIC:						return _T("Kontrolle der autom. Netzwerk Rckfrage NAFC");
				case IDS_PPG_MAELLA_NAFC_STATIC01:						return _T("Network Adapter Feedback Control");
				case IDS_PPG_MAELLA_NAFC_STATIC02:						return _T("Upload Grenzwert kB/s");
				case IDS_PPG_MAELLA_NAFC_CHECK01:						return _T("Kontrolliere Uploadslots ffnung mit NAFC");
				case IDS_PPG_MAELLA_NAFC_CHECK02:						return _T("Auto U/D Limit");
				case IDS_PPG_MAELLA_NUSS_CHECK01:						return _T("Aktivere neue Uploadslot ffnung");
				case IDS_PPG_MAELLA_CONNECTION_STATIC:					return _T("Anmerkung: Die Aktivierung einiger Parameter knnte verzgern");
				case IDS_PPG_MAELLA_CORRUPTION_STATIC:					return _T("Antikorruption");
				case IDS_PPG_MAELLA_CORRUPTION_CHECK:					return _T("Neutralisieren verdchtige Pakete");
				case IDS_PPG_MAELLA_SKIP_CORRUPTION_CD_CHECK:			return _T("Zeilensprungtest fr CD-Image (z.B. bin, nrg)");
				case IDS_PPG_MAELLA_IPFILTER_STATIC:					return _T("IP-Filter");
				case IDS_PPG_MAELLA_IPFILTER_VERSION_STATIC:			return _T("aktuell runtergeladene Version: %u");
				case IDS_PPG_MAELLA_UPDATE_IPFILTER_BUTTON:				return _T("Aktualisieren");
				case IDS_PPG_MAELLA_XS_CHECK:							return _T("Quellenaustausch mit den Clienten abschalten");
				case IDS_PPG_MAELLA_ZOOM_STATIC02:						return _T("Vergrssere um %ux");
				case IDS_PPG_MAELLA_SAMPLERATE_STATIC01:				return _T("Zeige Bandbreitenmessung in der bertragunstafel an");
				case IDS_PPG_MAELLA_SAMPLERATE_STATIC02a:				return _T("Zeit fr die Durchschnittliche-Datenrate 1 Sekunde");
				case IDS_PPG_MAELLA_SAMPLERATE_STATIC02b:				return _T("Zeit fr die Durchschnittliche-Datenrate %u Sekunden");
				case IDS_PPG_MAELLA_FILTER_STATIC:						return _T("Filter fr ");
				case IDS_PPG_MAELLA_FILTER_CHECK01:						return _T("Upload Session endete aufgrund von...");
				case IDS_PPG_MAELLA_FILTER_CHECK04:						return _T("gefilterte IP:...");
 				case IDS_PPG_MAELLA_FILTER_CHECK05:						return _T("'gefilterte IP Quelle IP=...'");
				case IDS_PPG_MAELLA_FILTER_CHECK06:						return _T("'gefilterte IP Server mit IP=...'");
				case IDS_PPG_MAELLA_FILTER_CHECK07:						return _T("Maella's spezifische Nachrichten");
				case IDS_PPG_MAELLA_FILTER_CHECK08:						return _T("Maella's spezifische Debug Nachrichten");
				case IDS_PPG_MAELLA_FILTER_CHECK09:						return _T("Phoenix's spezifische Debug Nachrichten"); // [TPT] - Filter eigene Nachrichten
				case IDS_PPG_MAELLA_FILTER_CHECK10:						return _T("Handshake Debug Nachrichten"); // [TPT] - Filter Handshake Nachrichten
				case IDS_PPG_MAELLA_MINIDUMP_STATIC:					return _T("Weise darauf hin: Library CrashRpt.dll geladen");
				case IDS_PPG_MAELLA_MULTI_QUEUE_STATIC:					return _T("Mehrfachwarteschlange (Multi-Queues) upload");
				case IDS_PPG_MAELLA_MULTI_QUEUE_CHECK01:				return _T("Benutze Multi-Queue");
				case IDS_PPG_MAELLA_MULTI_QUEUE_CHECK02:				return _T("Reserviere einen Release-Slot");
				//case IDS_PPG_MAELLA_NUSS_CHECK01:						return _T("Aktiviere neue Uploadslot ffnung");
				case IDS_PPG_MAELLA_A4AF_STATIC:						return _T("A4AF");
				case IDS_PPG_MAELLA_A4AF_CHECK:							return _T("bertrage A4AF zur nchsten Datei der selben Kategorie");
				case IDS_PPG_MAELLA_REASK_SOURCE_AFTER_IP_CHANGE_CHECK:	return _T("Quellenneuabfrage nach Zwangstrennung (IP-Wechsel)");
				case IDS_PPG_PHOENIX_URLFORUPDATE:						return _T("URL zum aktualisieren");
				case IDS_PPG_SNAFUGROUP:								return _T("Fortgeschrittene Antileecher Kontrolle");
				case IDS_PPG_PHOENIX_SNAFU:								return _T("Aktiviere S.N.A.F.U. V2");
				case IDS_PPG_PHOENIX_ACT:								return _T("Aktiviere Anti Credit Diebstahl");
				case IDS_PPG_PHOENIX_FRIENDSHARE:						return _T("Aktiviere Anti Friendshare Mods ");
				case IDS_PPG_PHOENIX_CUMULATEBW:						return _T("Bandbreite zusammenfassen");
			}
			break;

		case LANG_FRENCH:
			switch(ID){
				case IDS_PPG_MAELLA_COMPENSATEOVERHEAD:						return _T("Limiter largeur de bande des donnes+controls");
				case IDS_PPG_MAELLA_MTU_STATIC:								return _T("MTU (gamme 200..1500, valeur par dfaut 1340)");
				case IDS_PPG_MAELLA_MIN_SLOT_STATIC:						return _T("Nbr min. slots d'upload (gamme 2..4, par dfaut 3)");
				// case IDS_PPG_MAELLA_SND_SOCKET_SIZE_STATIC:				return _T("Send buffer size (range %u..8000, default value 8000)");
				// case IDS_PPG_MAELLA_CONNECTION_STATIC:					return _T("Remark: some parameters might need sometime to be applied");
				// case IDS_PPG_MAELLA_NAFC_STATIC:							return _T("Network Adapter Feedback Control");
				// case IDS_PPG_MAELLA_NAFC_CHECK01:						return _T("Enable NAFC");
				// case IDS_PPG_MAELLA_NAFC_CHECK02:						return _T("Full auto-bandwidth control");
				case IDS_PPG_MAELLA_CORRUPTION_STATIC:						return _T("Anti-corruption");
				case IDS_PPG_MAELLA_CORRUPTION_CHECK:						return _T("Neutraliser les paquets suspects");
				case IDS_PPG_MAELLA_SKIP_CORRUPTION_CD_CHECK:				return _T("Ne pas tester les images CD (ex: .bin, .nrg)");
				case IDS_PPG_MAELLA_IPFILTER_STATIC:						return _T("Filtres IP");
				case IDS_PPG_MAELLA_IPFILTER_VERSION_STATIC:				return _T("Version actuelle tlcharge du fichier: %u");
				case IDS_PPG_MAELLA_UPDATE_IPFILTER_BUTTON:	   				return _T("Mise  jour");
				case IDS_PPG_MAELLA_XS_CHECK:								return _T("Dsactiver l'change de sources entre clients");
				case IDS_PPG_MAELLA_ZOOM_STATIC02:							return _T("Zoom %ux");
				case IDS_PPG_MAELLA_SAMPLERATE_STATIC01:					return _T("Mesure bande passante dans panneau de transferts");
				case IDS_PPG_MAELLA_SAMPLERATE_STATIC02a:					return _T("Bande passante moyenne pour 1 seconde");
				case IDS_PPG_MAELLA_SAMPLERATE_STATIC02b:					return _T("Bande passante moyenne pour %u secondes");

				case IDS_PPG_MAELLA_FILTER_STATIC:							return _T("Filtres pour ");
				// case IDS_PPG_MAELLA_FILTER_CHECK01:						return _T("Upload session ended due to...");
				
				
				// case IDS_PPG_MAELLA_FILTER_CHECK04:						return _T("Extended clean-up, delete client...");

				case IDS_PPG_MAELLA_MINIDUMP_STATIC:						return _T("Remarque: librarie CrashRpt.dll charge");					
				case IDS_PPG_MAELLA_MULTI_QUEUE_STATIC:						return _T("File d'attente multiple");
				case IDS_PPG_MAELLA_MULTI_QUEUE_CHECK01:					return _T("Activer file d'attente multiple");
				case IDS_PPG_MAELLA_MULTI_QUEUE_CHECK02:					return _T("Rserver un slot pour les fichiers en mode release");
				case IDS_PPG_MAELLA_A4AF_STATIC:							return _T("A4AF");
				case IDS_PPG_MAELLA_A4AF_CHECK:								return _T("Transfert A4AF au fichier suivant de la mme catgorie");

				case IDS_PPG_MAELLA_REASK_SOURCE_AFTER_IP_CHANGE_CHECK:		return _T("Rinitialiser les sources aprs reconnection modem");
			}
			break;

		case LANG_SPANISH:
			switch(ID){
				case IDS_PPG_MAELLA_COMPENSATEOVERHEAD:						return _T("Aplicar lmites a datos+ancho de banda excedente");
				case IDS_PPG_MAELLA_MTU_STATIC:								return _T("MTU (rango 200..1500, valor por defecto 1340)");
				case IDS_PPG_MAELLA_MIN_SLOT_STATIC:						return _T("Puestos Mnimos de subida (rango 2..4, defecto 3)");
				// case IDS_PPG_MAELLA_SND_SOCKET_SIZE_STATIC:				return _T("Send buffer size (range %u..8000, default value 8000)");
				// case IDS_PPG_MAELLA_CONNECTION_STATIC:					return _T("Remark: some parameters might need sometime to be applied");
				// case IDS_PPG_MAELLA_NAFC_STATIC:							return _T("Network Adapter Feedback Control");
				// case IDS_PPG_MAELLA_NAFC_CHECK01:						return _T("Enable NAFC");
				// case IDS_PPG_MAELLA_NAFC_CHECK02:						return _T("Full auto-bandwidth control");
				case IDS_PPG_MAELLA_CORRUPTION_STATIC:						return _T("Anticorrupcin");
				case IDS_PPG_MAELLA_CORRUPTION_CHECK:						return _T("Desechar partes corrompida");
				case IDS_PPG_MAELLA_SKIP_CORRUPTION_CD_CHECK:				return _T("No probar las imgenes CD (ex: bin, nrg)");
				case IDS_PPG_MAELLA_IPFILTER_STATIC:						return _T("Filtrar IP");
				case IDS_PPG_MAELLA_IPFILTER_VERSION_STATIC:				return _T("Versin descargada actual: %u");
				case IDS_PPG_MAELLA_UPDATE_IPFILTER_BUTTON:	   				return _T("Actualizar");
				case IDS_PPG_MAELLA_XS_CHECK:								return _T("Desactivar intercambio de fuente entre clientes");
				case IDS_PPG_MAELLA_ZOOM_STATIC02:							return _T("Zoom %ux");
				case IDS_PPG_MAELLA_SAMPLERATE_STATIC01:					return _T("Medicin del ancho de banda en Panel de Transferencas");
				case IDS_PPG_MAELLA_SAMPLERATE_STATIC02a:					return _T("Tiempo para calcular medias 1 segundo");
				case IDS_PPG_MAELLA_SAMPLERATE_STATIC02b:					return _T("Tiempo para calcular medias %u segundos");

				case IDS_PPG_MAELLA_FILTER_STATIC:							return _T("Filtros para ");
				// case IDS_PPG_MAELLA_FILTER_CHECK01:						return _T("Upload session ended due to...");
				
				
				// case IDS_PPG_MAELLA_FILTER_CHECK04:						return _T("Extended clean-up, delete client...");

				case IDS_PPG_MAELLA_MINIDUMP_STATIC:						return _T("Atencin: Librera CrashRpt.dll cargada");
				case IDS_PPG_MAELLA_MULTI_QUEUE_STATIC:						return _T("Subida Multi-Colas");
				case IDS_PPG_MAELLA_MULTI_QUEUE_CHECK01:					return _T("Usar multi-cola");
				case IDS_PPG_MAELLA_MULTI_QUEUE_CHECK02:					return _T("Reservar un slot para Lanzamiento");
				case IDS_PPG_MAELLA_A4AF_STATIC:							return _T("A4AF");
				case IDS_PPG_MAELLA_A4AF_CHECK:								return _T("Cambiar A4AF a otro de la misma categoria");

				case IDS_PPG_MAELLA_REASK_SOURCE_AFTER_IP_CHANGE_CHECK:		return _T("No repreguntar fuentes despues de LowID<->HighID");
				case IDS_PPG_PHOENIX_SNAFU:									return _T("Activar S.N.A.F.U V2");
				case IDS_PPG_PHOENIX_ACT:									return _T("Activar Anti robo de creditos");
				case IDS_PPG_PHOENIX_FRIENDSHARE:							return _T("Activar Anti FriendShare Mods");
				case IDS_PPG_SNAFUGROUP:									return _T("Control Avanzado AntiLeechers");
				case IDS_PPG_PHOENIX_CUMULATEBW:							return _T("Acumular Ancho de Banda en un slot");
				case IDS_PPG_PHOENIX_URLFORUPDATE:							return _T("URL para actualizar");
			}
			break;
	}
	
	// Default LANG_ENGLISH
	switch(ID){
		case IDS_PPG_MAELLA_COMPENSATEOVERHEAD:							return _T("Apply bandwidth limits to overhead+data");
		case IDS_PPG_MAELLA_MTU_STATIC:									return _T("MTU (range 200..1500, default value 1340)");
		case IDS_PPG_MAELLA_MIN_SLOT_STATIC:							return _T("Minimum upload slots (range 2..4, default value 3)");
		case IDS_PPG_MAELLA_SND_SOCKET_SIZE_STATIC:						return _T("Send socket buffer size\n(range %u..8192, default value 8192)");
		case IDS_PPG_MAELLA_NAFC_STATIC01:								return _T("Network Adapter Feedback Control");
		case IDS_PPG_MAELLA_NAFC_STATIC02:								return _T("Upload threshold kB/s");
		case IDS_PPG_MAELLA_NAFC_CHECK01:								return _T("Control upload slots sharping with NAFC");
		case IDS_PPG_MAELLA_NAFC_CHECK02:								return _T("Auto U/D limits");
		case IDS_PPG_MAELLA_CONNECTION_STATIC:							return _T("Remark: the activation of some parameters might be delayed");
		case IDS_PPG_MAELLA_CORRUPTION_STATIC:							return _T("Anti-corruption");
		case IDS_PPG_MAELLA_CORRUPTION_CHECK:							return _T("Defeat corrupted part");
		case IDS_PPG_MAELLA_SKIP_CORRUPTION_CD_CHECK:					return _T("Skip test for CD-Image (e.g. .bin, .nrg)");
		case IDS_PPG_MAELLA_IPFILTER_STATIC:							return _T("IP-Filter");
		case IDS_PPG_MAELLA_IPFILTER_VERSION_STATIC:					return _T("Current downloaded version: %u");
		case IDS_PPG_MAELLA_UPDATE_IPFILTER_BUTTON:			     		return _T("Update");
		case IDS_PPG_MAELLA_XS_CHECK:									return _T("Disable source exchanging between clients");
		case IDS_PPG_MAELLA_ZOOM_STATIC02:								return _T("Zoom %ux");
		case IDS_PPG_MAELLA_SAMPLERATE_STATIC01:						return _T("Bandwidth measurement in Transfers panel");
		case IDS_PPG_MAELLA_SAMPLERATE_STATIC02a:						return _T("Time for Average-Datarate 1 second");
		case IDS_PPG_MAELLA_SAMPLERATE_STATIC02b:						return _T("Time for Average-Datarate %u seconds");
		case IDS_PPG_MAELLA_FILTER_STATIC:								return _T("Filters for ");
		case IDS_PPG_MAELLA_FILTER_CHECK01:								return _T("'Upload session ended due to...'");		
		case IDS_PPG_MAELLA_FILTER_CHECK04:								return _T("'Filtered IP: ...'");
		case IDS_PPG_MAELLA_FILTER_CHECK05:								return _T("'IPfiltered source IP=...'");
		case IDS_PPG_MAELLA_FILTER_CHECK06:								return _T("'IPfiltered server with IP=...'");
		case IDS_PPG_MAELLA_FILTER_CHECK07:								return _T("Maella's specific messages");
		case IDS_PPG_MAELLA_FILTER_CHECK08:								return _T("Maella's specific debug messages");
		case IDS_PPG_MAELLA_FILTER_CHECK09:								return _T("Phoenix's specific debug messages"); // [TPT] - Filter own messages
		case IDS_PPG_MAELLA_FILTER_CHECK10:								return _T("Handshake debug messages"); // [TPT] - Filter Handshake messages
		case IDS_PPG_MAELLA_MINIDUMP_STATIC:							return _T("Remark: Library CrashRpt.dll loaded");
		case IDS_PPG_MAELLA_MULTI_QUEUE_STATIC:							return _T("Multi-Queues upload");
		case IDS_PPG_MAELLA_MULTI_QUEUE_CHECK01:						return _T("Use multi-queue");
		case IDS_PPG_MAELLA_MULTI_QUEUE_CHECK02:						return _T("Reserve one slot for release");
		case IDS_PPG_MAELLA_NUSS_CHECK01:						        return _T("Enable new Upload Slot Sharping");
        case IDS_PPG_MAELLA_A4AF_STATIC:								return _T("A4AF");
		case IDS_PPG_MAELLA_A4AF_CHECK:									return _T("Transfer A4AF to next file within the same category");
		case IDS_PPG_MAELLA_REASK_SOURCE_AFTER_IP_CHANGE_CHECK:			return _T("Don't reask sources after LowID<->HighID");	
		case IDS_PPG_PHOENIX_SNAFU:										return _T("Enable S.N.A.F.U V2");
		case IDS_PPG_PHOENIX_ACT:										return _T("Enable AntiCredit Theft");
		case IDS_PPG_PHOENIX_FRIENDSHARE:								return _T("Enable Anti Friendshare MODS");
		case IDS_PPG_SNAFUGROUP:										return _T("Advanced Antileechers Control");
		case IDS_PPG_PHOENIX_CUMULATEBW:								return _T("Cumulate Bandwidth");
		case IDS_PPG_PHOENIX_URLFORUPDATE:								return _T("URL for updating");
	}
	// Error
	return _T("missing string");
};

// Maella -MiniDump/CrashRpt-
// Remark: should be stored in in other file
class MiniDump{
public:
	MiniDump(){
		m_pCrashRptState = NULL;
		//m_hInstCrashBlackBox = NULL;
		m_hInstCrashRpt = NULL;
		LoadCrashRptLibrary();
	}
	
	~MiniDump(){
		UnloadCrashRptLibrary();
	}

	bool IsMiniDumpActivated() {return m_pCrashRptState != NULL;}

private:
	// Client crash callback
	typedef BOOL (CALLBACK *LPGETLOGFILE) (LPVOID lpvState);
	
	//-----------------------------------------------------------------------------
	// Install
	//    Initializes the library and optionally set the client crash callback and
	//    sets up the email details.
	//
	// Parameters
	//    pfn         Client crash callback
	//    lpTo        Email address to send crash report
	//    lpSubject   Subject line to be used with email
	//
	// Return Values
	//    If the function succeeds, the return value is a pointer to the underlying
	//    crash object created.  This state information is required as the first
	//    parameter to all other crash report functions.
	//
	// Remarks
	//    Passing NULL for lpTo will disable the email feature and cause the crash 
	//    report to be saved to disk.
	//
	typedef LPVOID (*INSTALL) (LPGETLOGFILE pfn, LPCTSTR lpTo, LPCTSTR lpSubject);

	//-----------------------------------------------------------------------------
	// Uninstall
	//    Uninstalls the unhandled exception filter set up in Install().
	//
	// Parameters
	//    lpState     State information returned from Install()
	//
	// Return Values
	//    void
	//
	// Remarks
	//    This call is optional.  The crash report library will automatically 
	//    deinitialize when the library is unloaded.  Call this function to
	//    unhook the exception filter manually.
	//
	typedef void (*UNINSTALL)(LPVOID lpState);

	//-----------------------------------------------------------------------------
	// AddFile
	//    Adds a file to the crash report.
	//
	// Parameters
	//    lpState     State information returned from Install()
	//    lpFile      Fully qualified file name
	//    lpDesc      Description of file, used by details dialog
	//
	// Return Values
	//    void
	//
	// Remarks
	//    This function can be called anytime after Install() to add one or more
	//    files to the generated crash report.
	//
	typedef void (*ADDFILE)(LPVOID lpState, LPCTSTR lpFile, LPCTSTR lpDesc);

	//-----------------------------------------------------------------------------
	// GenerateErrorReport
	//    Generates the crash report.
	//
	// Parameters
	//    lpState     State information returned from Install()
	//    pExInfo     Pointer to an EXCEPTION_POINTERS structure
	//
	// Return Values
	//    void
	//
	// Remarks
	//    Call this function to manually generate a crash report.
	//
	typedef void (*GENERATEERRORREPORT)(LPVOID lpState, PEXCEPTION_POINTERS pExInfo);

	void LoadCrashRptLibrary(){
		m_hInstCrashRpt = ::LoadLibrary("CrashRpt.dll");
		if(m_hInstCrashRpt != NULL){
			// Load pointer to function
			INSTALL Install = (INSTALL)GetProcAddress(m_hInstCrashRpt, "Install");
			// Start library
			m_pCrashRptState = Install(NULL, "thephoenixteam@yahoo.es", theApp.m_strCurVersionLong);
			// Display a message box
			// ::MessageBox(NULL, _T("CrashRpt.dll located\n\nA miniDump file would be generated during a crash of this application"), _T("MiniDump activated"), MB_ICONASTERISK);
		}		
	}

	void UnloadCrashRptLibrary(){
		if(m_hInstCrashRpt != NULL){
			// Load pointer to function
			UNINSTALL Uninstall = (UNINSTALL)GetProcAddress(m_hInstCrashRpt, "Uninstall");
			Uninstall(m_pCrashRptState);
			m_pCrashRptState = NULL;

			// Release library
			if(::FreeLibrary(m_hInstCrashRpt) == TRUE){
				m_hInstCrashRpt = NULL;
			}
		}		
	}

	// Don't allow canonical behavior
	MiniDump(const MiniDump&);
	MiniDump& operator=(const MiniDump&);

private:
	void*		m_pCrashRptState;
	HINSTANCE	m_hInstCrashRpt;
} s_miniDump;
// Maella end

// Maella -Test PasaKche-
// This library makes eMule unstable
// see http://www.internautas.org/article.php?sid=1110
class TestPasaKche{
public:
	TestPasaKche(){
		TestPasaKcheLibrary();
	}
	
	~TestPasaKche(){
	}

private:
	void TestPasaKcheLibrary(){
		// try to load the library
		HINSTANCE m_hInstance = ::LoadLibrary("pasakche.dll");
		if(m_hInstance != NULL){

			// Release library
			::FreeLibrary(m_hInstance);

			// Warning
			::MessageBox(NULL,
						_T("Warning, PasaKche detected. This library makes pHoenix unstable.\n\n"
						   "Attention, PasaKche dtect. Cette librarie peut rendre pHoenix instable.\n\n"
						   "Achtung, PasaKche gefunden. Diese Bibliothek ist inkompatibel mit pHoenix.\n\n"
						   "Atencion,  PasaKche encontrado. Esta biblioteca es incompatible con pHoenix."),
						_T("Warning/Attention/Achtung/Atencion"), 
						MB_ICONWARNING);
		}
	}

	// Don't allow canonical behavior
	TestPasaKche(const TestPasaKche&);
	TestPasaKche& operator=(const TestPasaKche&);

} s_testPasaKche;
// Maella end

// CPPgMaella dialog

IMPLEMENT_DYNAMIC(CPPgMaella, CPreferencesPage)	// [TPT] - SLUGFILLER: modelessDialogs
CPPgMaella::CPPgMaella()
	: CPreferencesPage(CPPgMaella::IDD) // [TPT] - SLUGFILLER: modelessDialogs
{
	// Create an icon list for the tab control	
	m_imageList.Create(16, 16, theApp.m_iDfltImageListColorFlags | ILC_MASK, 0, 1);
	m_imageList.Add(CTempIconLoader("PREF_GENERAL"));
	m_imageList.Add(CTempIconLoader("PREF_DISPLAY"));
	m_imageList.Add(CTempIconLoader("PREF_CONNECTION"));
	m_imageList.Add(CTempIconLoader("PREF_PROXY"));
	m_imageList.Add(CTempIconLoader("PREF_SERVER"));
	m_imageList.Add(CTempIconLoader("PREF_FOLDERS"));
	m_imageList.Add(CTempIconLoader("PREF_FILES"));
	m_imageList.Add(CTempIconLoader("PREF_NOTIFICATIONS"));
	m_imageList.Add(CTempIconLoader("PREF_STATISTICS"));
	m_imageList.Add(CTempIconLoader("PREF_IRC"));
	m_imageList.Add(CTempIconLoader("PREF_SECURITY"));
	m_imageList.Add(CTempIconLoader("PREF_SCHEDULER"));
	m_imageList.Add(CTempIconLoader("PREF_VIRTUAL"));	// [TPT] - itsonlyme: virtualDirs
	m_imageList.Add(CTempIconLoader("PREF_WEBSERVER"));
	m_imageList.Add(CTempIconLoader("PREF_TWEAK"));
	m_imageList.Add(CTempIconLoader("PHOENIX")); // Maella -New setting panels => Tweaks II- // [TPT]
	m_imageList.Add(CTempIconLoader("PHOENIX")); // [TPT]	
}

CPPgMaella::~CPPgMaella()
{
}

void CPPgMaella::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_PPG_MAELLA_TAB, m_tabCtr);
}

BEGIN_MESSAGE_MAP(CPPgMaella, CPreferencesPage) // [TPT] - SLUGFILLER: modelessDialogs
	// TAB control
	ON_NOTIFY(TCN_SELCHANGE, IDC_PPG_MAELLA_TAB, OnTabSelectionChange)

	// Maella -Overhead compensation (pseudo full rate control)-
	ON_BN_CLICKED(IDC_PPG_MAELLA_COMPENSATEOVERHEAD, OnSettingsChange)

	// Maella -MTU Configuration-
	ON_EN_CHANGE(IDC_PPG_MAELLA_MTU_EDIT, OnSettingsChange) 

	// Maella -Minimum Upload Slot-
	ON_EN_CHANGE(IDC_PPG_MAELLA_MIN_SLOT_EDIT, OnSettingsChange) 

	// Maella -New bandwidth control-
	ON_EN_CHANGE(IDC_PPG_MAELLA_SND_SOCKET_SIZE_EDIT, OnSettingsChange) 
	ON_EN_CHANGE(IDC_PPG_MAELLA_NAFC_EDIT, OnSettingsChange) 
	ON_BN_CLICKED(IDC_PPG_MAELLA_NAFC_CHECK01, OnNAFCChange) 
	ON_BN_CLICKED(IDC_PPG_MAELLA_NAFC_CHECK02, OnNAFCChange) 

	// Maella -Accurate measure of bandwidth: eDonkey data + control, network adapter-
	ON_WM_HSCROLL()

	// Maella -Defeat 0-filled Part Senders- (Idea of xrmb)
	ON_BN_CLICKED(IDC_PPG_MAELLA_CORRUPTION_CHECK, OnCorruptionCheckChange) 
	ON_BN_CLICKED(IDC_PPG_MAELLA_SKIP_CORRUPTION_CD_CHECK, OnSettingsChange) 
	
	// Maella -Enable/Disable source exchange in preference- (Tarod)
	ON_BN_CLICKED(IDC_PPG_MAELLA_XS_CHECK, OnSettingsChange) 
	ON_BN_CLICKED(IDC_PPG_MAELLA_REASK_SOURCE_AFTER_IP_CHANGE_CHECK, OnSettingsChange) 

	// Maella -Filter verbose messages-
	ON_BN_CLICKED(IDC_PPG_MAELLA_FILTER_VERBOSE_CHECK01, OnSettingsChange) 
	
	
	ON_BN_CLICKED(IDC_PPG_MAELLA_FILTER_VERBOSE_CHECK04, OnSettingsChange) 
	ON_BN_CLICKED(IDC_PPG_MAELLA_FILTER_VERBOSE_CHECK05, OnSettingsChange) 
	ON_BN_CLICKED(IDC_PPG_MAELLA_FILTER_VERBOSE_CHECK06, OnSettingsChange) 
	ON_BN_CLICKED(IDC_PPG_MAELLA_FILTER_VERBOSE_CHECK07, OnSettingsChange) 
	ON_BN_CLICKED(IDC_PPG_MAELLA_FILTER_VERBOSE_CHECK08, OnSettingsChange) 
	ON_BN_CLICKED(IDC_PPG_MAELLA_FILTER_VERBOSE_CHECK09, OnSettingsChange)  // [TPT] - Filter own messages
	ON_BN_CLICKED(IDC_PPG_MAELLA_FILTER_VERBOSE_CHECK10, OnSettingsChange)  // [TPT] - Filter Handshake messages

	// Maella -One-queue-per-file- (idea bloodymad)
	ON_BN_CLICKED(IDC_PPG_MAELLA_MULTI_QUEUE_CHECK01, OnMultiQueueChange) 
	ON_BN_CLICKED(IDC_PPG_MAELLA_MULTI_QUEUE_CHECK02, OnSettingsChange) 
	ON_BN_CLICKED(IDC_PPG_MAELLA_NUSS_CHECK01, OnSettingsChange) 

	// Maella -Auto A4AF-
	ON_BN_CLICKED(IDC_PPG_MAELLA_A4AF_CHECK, OnSettingsChange) 

	//eWombat [SNAFU][TPT]
	ON_BN_CLICKED(IDC_PPG_PHOENIX_SNAFU_CHECK, OnSettingsChange) 
	ON_BN_CLICKED(IDC_PPG_PHOENIX_ACT_CHECK, OnSettingsChange) 
	ON_BN_CLICKED(IDC_PPG_PHOENIX_FRIENDSHARE_CHECK, OnSettingsChange) 
	//eWombat [SNAFU][TPT]

	//[TPT]-Cumulate Bandwidth
	ON_BN_CLICKED(IDC_PPG_PHOENIX_CUMULATEBW, OnSettingsChange) 


END_MESSAGE_MAP()

// CPPgMaella message handlers

BOOL CPPgMaella::OnInitDialog()
{
	CPropertyPage::OnInitDialog();

	// Init the Tab control
	InitTab();

	// Create and Init all controls
	InitControl();

	// Set default tab
	m_currentTab = NONE;
	m_tabCtr.SetCurSel(0);
	SetTab(CONNECTION);

	// Load setting
	LoadSettings();
	Localize();

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

void CPPgMaella::LoadSettings()
{
	// Maella -Overhead compensation (pseudo full rate control)-
	m_compOverheadCheck.SetCheck((thePrefs.GetCompensateOverhead() == true) ? BST_CHECKED : BST_UNCHECKED);

	// Maella -MTU Configuration-
	{
		CString buffer;
		buffer.Format(_T("%u"), thePrefs.GetMTU());
		m_MTUEdit.SetWindowText(buffer);
	}

	// Maella -Minimum Upload Slot-
	{
		CString buffer;
		buffer.Format(_T("%u"), thePrefs.GetMinUploadSlot());
		m_minSlotEdit.SetWindowText(buffer);
	}

	// Maella -New bandwidth control-
	{
		CString buffer;
		buffer.Format(_T("%u"), thePrefs.GetSendSocketBufferSize());
		m_sndSocketSizeEdit.SetWindowText(buffer);
	}

	// Maella -Network Adapter Feedback Control-
	m_NAFCCheck01.EnableWindow(theApp.pBandWidthControl->IsNAFCAvailable() == true);
	m_NAFCCheck01.SetCheck((thePrefs.GetNAFCEnable() == true) ? BST_CHECKED : BST_UNCHECKED);
	m_NAFCCheck02.EnableWindow(theApp.pBandWidthControl->IsNAFCAvailable() == true && m_NAFCCheck01.GetCheck() != BST_UNCHECKED);
	m_NAFCCheck02.SetCheck((thePrefs.GetNAFCFullControl() == true) ? BST_CHECKED : BST_UNCHECKED);
	{
		CString buffer;
		m_NAFCEdit.EnableWindow(m_NAFCCheck01.GetCheck() == BST_CHECKED);
		buffer.Format(_T("%.1f"), thePrefs.GetNAFCNetworkOut());
		m_NAFCEdit.SetWindowText(buffer);
	}

	// Maella -Defeat 0-filled Part Senders- (Idea of xrmb)
	m_corruptionCheck.SetCheck((thePrefs.GetCorruptionTest() == true) ? BST_CHECKED : BST_UNCHECKED);
	m_skipCorruptionCDCheck.EnableWindow(m_corruptionCheck.GetCheck() != BST_UNCHECKED);
	m_skipCorruptionCDCheck.SetCheck((thePrefs.GetSkipCorruptionCDTest() == true) ? BST_CHECKED : BST_UNCHECKED);

	// Maella -Graph: display zoom-
	m_zoomSlider.SetPos(thePrefs.GetZoomFactor());

	// Maella -Accurate measure of bandwidth: eDonkey data + control, network adapter-
	m_sampleRateSlider.SetPos(thePrefs.GetDatarateSamples());

	// Maella -Enable/Disable source exchange in preference- (Tarod)
	m_XSCheck.SetCheck((thePrefs.GetDisabledXS() == true) ? BST_CHECKED : BST_UNCHECKED);

	// Maella -Reask sources after IP change- (idea Xman)
	m_reaskSourceAfterIPChangeCheck.SetCheck((thePrefs.GetReaskSourceAfterIPChange() != true) ? BST_CHECKED : BST_UNCHECKED); // [TPT]

	// Maella -Filter verbose messages-
	m_filterVerboseCheck01.SetCheck((thePrefs.GetBlockUploadEndMsg() == true) ? BST_CHECKED : BST_UNCHECKED);
	m_filterVerboseCheck01.EnableWindow((thePrefs.GetVerbose() == false) ? FALSE : TRUE);	
	//m_filterVerboseCheck04.SetCheck((thePrefs.GetLogFilteredIPs() == true) ? BST_CHECKED : BST_UNCHECKED);
	//m_filterVerboseCheck04.EnableWindow((thePrefs.GetVerbose() == false) ? FALSE : TRUE);
	m_filterVerboseCheck05.SetCheck((thePrefs.GetBlockFilteredIPSourceMsg() == true) ? BST_CHECKED : BST_UNCHECKED);
	m_filterVerboseCheck05.EnableWindow((thePrefs.GetVerbose() == false) ? FALSE : TRUE);
	m_filterVerboseCheck06.SetCheck((thePrefs.GetBlockFilteredIPServerMsg() == true) ? BST_CHECKED : BST_UNCHECKED);
	m_filterVerboseCheck06.EnableWindow((thePrefs.GetVerbose() == false) ? FALSE : TRUE);
	m_filterVerboseCheck07.SetCheck((thePrefs.GetBlockMaellaSpecificMsg() == true) ? BST_CHECKED : BST_UNCHECKED);
	m_filterVerboseCheck07.EnableWindow((thePrefs.GetVerbose() == false) ? FALSE : TRUE);
	m_filterVerboseCheck08.SetCheck((thePrefs.GetBlockMaellaSpecificDebugMsg() == true) ? BST_CHECKED : BST_UNCHECKED);
	m_filterVerboseCheck08.EnableWindow((thePrefs.GetVerbose() == false) ? FALSE : TRUE);
	// [TPT] - Filter own messages
	m_filterVerboseCheck09.SetCheck((thePrefs.GetBlockPhoenixMsg() == true) ? BST_CHECKED : BST_UNCHECKED);
	m_filterVerboseCheck09.EnableWindow((thePrefs.GetVerbose() == false) ? FALSE : TRUE);
	// [TPT] - Filter Handshake messages
	m_filterVerboseCheck10.SetCheck((thePrefs.GetBlockHandshakeMsg() == true) ? BST_CHECKED : BST_UNCHECKED);
	m_filterVerboseCheck10.EnableWindow((thePrefs.GetVerbose() == false) ? FALSE : TRUE);

	// Maella -One-queue-per-file- (idea bloodymad)
	m_multiQueueCheck01.SetCheck((thePrefs.GetEnableMultiQueue() == true) ? BST_CHECKED : BST_UNCHECKED);
	m_multiQueueCheck02.EnableWindow(m_multiQueueCheck01.GetCheck() != BST_UNCHECKED);
	m_multiQueueCheck02.SetCheck((thePrefs.GetEnableReleaseMultiQueue() == true) ? BST_CHECKED : BST_UNCHECKED);

	// Maella -Auto A4AF-
	m_A4AFCheck.SetCheck((thePrefs.GetEnableA4AFTransfer() == true) ? BST_CHECKED : BST_UNCHECKED);

	//New Upload slot sharping
	m_newUploadSlotSharpingCheck.SetCheck((thePrefs.GetEnableNewUSS() == true) ? BST_CHECKED : BST_UNCHECKED);
	

	//eWombat [SNAFU][TPT]
	m_iSnafu.SetCheck(thePrefs.GetAntiSnafu());
	m_iAntiCreditTheft.SetCheck(thePrefs.GetAntiCreditTheft());
	m_iAntiFriendshare.SetCheck(thePrefs.GetAntiFriendshare());
	//eWombat [SNAFU][TPT]


	//[TPT]-Cumulate Bandwidth
	m_iCumulateBW.SetCheck(thePrefs.IsCumulateBandwidthEnabled());



}

BOOL CPPgMaella::OnApply()
{
	// Maella -Overhead compensation (pseudo full rate control)-
	thePrefs.SetCompensateOverhead(m_compOverheadCheck.GetCheck() != BST_UNCHECKED);

	// Maella -MTU Configuration-
	{
		CString buffer;
		m_MTUEdit.GetWindowText(buffer);
		int MTU = _tstoi(buffer);
		if(MTU > 1500) MTU = 1500;
		if(MTU < 250) MTU = 250;
		thePrefs.SetMTU(MTU);
	}

	// Maella -Minimum Upload Slot-
	{
		CString buffer;
		m_minSlotEdit.GetWindowText(buffer);
		int minUploadSlot = _tstoi(buffer);
		if(minUploadSlot > 4) minUploadSlot = 4;
		if(minUploadSlot < 2) minUploadSlot = 2;
		thePrefs.SetMinUploadSlot(minUploadSlot);
	}

	// Maella -New bandwidth control-
	{
		CString buffer;
		m_sndSocketSizeEdit.GetWindowText(buffer);
		int sendSocketBufferSize = _tstoi(buffer);
		if(sendSocketBufferSize > 8192) sendSocketBufferSize = 8192;
		if(sendSocketBufferSize < MINIMUM_SEND_BUFFER_SIZE) sendSocketBufferSize = MINIMUM_SEND_BUFFER_SIZE;
		thePrefs.SetSendSocketBufferSize(sendSocketBufferSize);
	}

	// Maella -Network Adapter Feedback Control-
	thePrefs.SetNAFCEnable(m_NAFCCheck01.GetCheck() == BST_CHECKED);
	thePrefs.SetNAFCFullControl(m_NAFCCheck02.GetCheck() == BST_CHECKED);
	if(m_NAFCCheck01.GetCheck() == BST_CHECKED){
		CString buffer;
		m_NAFCEdit.GetWindowText(buffer);
		double networkOut = _tstof(buffer);
		thePrefs.SetNAFCNetworkOut(networkOut);
	}

	// Maella -Defeat 0-filled Part Senders- (Idea of xrmb)
	thePrefs.SetCorruptionTest(m_corruptionCheck.GetCheck() != BST_UNCHECKED);
	thePrefs.SetSkipCorruptionCDTest(m_skipCorruptionCDCheck.GetCheck() != BST_UNCHECKED);

	// Maella -Graph: display zoom-
	bool redrawMeter = (thePrefs.GetZoomFactor() != m_zoomSlider.GetPos());
	thePrefs.SetZoomFactor(m_zoomSlider.GetPos());

	// Maella -Accurate measure of bandwidth: eDonkey data + control, network adapter-
	thePrefs.SetDatarateSamples(m_sampleRateSlider.GetPos());

	// Maella -Enable/Disable source exchange in preference- (Tarod)
	thePrefs.SetDisabledXS(m_XSCheck.GetCheck() != BST_UNCHECKED);

	// Maella -Reask sources after IP change- (idea Xman)
	thePrefs.SetReaskSourceAfterIPChange(m_reaskSourceAfterIPChangeCheck.GetCheck() == BST_UNCHECKED); // [TPT]

	// Maella -Filter verbose messages-
	thePrefs.SetBlockUploadEndMsg(m_filterVerboseCheck01.GetCheck() != BST_UNCHECKED);		
	//thePrefs.SetLogFilteredIPs(m_filterVerboseCheck04.GetCheck() != BST_UNCHECKED);
	thePrefs.SetBlockFilteredIPSourceMsg(m_filterVerboseCheck05.GetCheck() != BST_UNCHECKED);
	thePrefs.SetBlockFilteredIPServerMsg(m_filterVerboseCheck06.GetCheck() != BST_UNCHECKED);
	thePrefs.SetBlockMaellaSpecificMsg(m_filterVerboseCheck07.GetCheck() != BST_UNCHECKED);
	thePrefs.SetBlockMaellaSpecificDebugMsg(m_filterVerboseCheck08.GetCheck() != BST_UNCHECKED);
	thePrefs.SetBlockPhoenixMsg(m_filterVerboseCheck09.GetCheck() != BST_UNCHECKED); // [TPT] - Filter own messages
	thePrefs.SetBlockHandshakeMsg(m_filterVerboseCheck10.GetCheck() != BST_UNCHECKED); // [TPT] - Filter Handshake messages

	// Maella -One-queue-per-file- (idea bloodymad)
	thePrefs.SetEnableMultiQueue(m_multiQueueCheck01.GetCheck() != BST_UNCHECKED);
	thePrefs.SetEnableReleaseMultiQueue(m_multiQueueCheck02.GetCheck() != BST_UNCHECKED);

	// Maella -Auto A4AF-
	thePrefs.SetEnableA4AFTransfer(m_A4AFCheck.GetCheck() != BST_UNCHECKED);

	//new upload slot sharping
    thePrefs.SetEnableNewUSS(m_newUploadSlotSharpingCheck.GetCheck() != BST_UNCHECKED);

	//eWombat [SNAFU][TPT]
	thePrefs.SetEnableSnafu(m_iSnafu.GetCheck() != BST_UNCHECKED);
	thePrefs.SetEnableACT(m_iAntiCreditTheft.GetCheck() != BST_UNCHECKED);
	thePrefs.SetEnableAntiFriendshare(m_iAntiFriendshare.GetCheck() != BST_UNCHECKED);
	//eWombat [SNAFU][TPT]

	//[TPT]-Cumulate Bandwidth
	thePrefs.SetCumulateBandwidth(m_iCumulateBW.GetCheck() != BST_UNCHECKED);



	// Refresh Setting
	LoadSettings();
	SetModified(FALSE);

	if(redrawMeter){
		theApp.emuledlg->statisticswnd->ShowInterval();
		theApp.emuledlg->statisticswnd->RepaintMeters();
		theApp.emuledlg->statisticswnd->GetDlgItem(IDC_STATTREE)->EnableWindow(thePrefs.GetStatsInterval()>0);
	}

	return CPropertyPage::OnApply();
}

void CPPgMaella::Localize(void)
{	
	if(m_hWnd)
	{
		CString Buffer;
		SetWindowText(_T("Maella's"));

		int row = m_tabCtr.GetRowCount();
		InitTab(); // To update string, could be improved
		if(row != 0 && row != m_tabCtr.GetRowCount()){
			// Shift all windows object
			// .. to do
		}

		// CONNECTION
		m_compOverheadCheck.SetWindowText(GetMaellaResString(IDS_PPG_MAELLA_COMPENSATEOVERHEAD));
		m_MTUStatic.SetWindowText(GetMaellaResString(IDS_PPG_MAELLA_MTU_STATIC));
		m_minSlotStatic.SetWindowText(GetMaellaResString(IDS_PPG_MAELLA_MIN_SLOT_STATIC));
		Buffer.Format(GetMaellaResString(IDS_PPG_MAELLA_SND_SOCKET_SIZE_STATIC), MINIMUM_SEND_BUFFER_SIZE);
		m_sndSocketSizeStatic.SetWindowText(Buffer);
		m_NAFCGroupBox.SetWindowText(GetMaellaResString(IDS_PPG_MAELLA_NAFC_STATIC01));
		m_NAFCStatic.SetWindowText(GetMaellaResString(IDS_PPG_MAELLA_NAFC_STATIC02));
		m_NAFCCheck01.SetWindowText(GetMaellaResString(IDS_PPG_MAELLA_NAFC_CHECK01));
		m_NAFCCheck02.SetWindowText(GetMaellaResString(IDS_PPG_MAELLA_NAFC_CHECK02));
		m_connectionStatic.SetWindowText(GetMaellaResString(IDS_PPG_MAELLA_CONNECTION_STATIC));
		m_iCumulateBW.SetWindowText(GetMaellaResString(IDS_PPG_PHOENIX_CUMULATEBW));



		// SECURITY
		m_corruptionGroupBox.SetWindowText(GetMaellaResString(IDS_PPG_MAELLA_CORRUPTION_STATIC));
		m_corruptionCheck.SetWindowText(GetMaellaResString(IDS_PPG_MAELLA_CORRUPTION_CHECK));
		m_skipCorruptionCDCheck.SetWindowText(GetMaellaResString(IDS_PPG_MAELLA_SKIP_CORRUPTION_CD_CHECK));
		
		m_userHashStatic.SetWindowText(GetResString(IDS_CD_UHASH));
		m_userHashEdit.SetWindowText(EncodeBase16((const unsigned char*)thePrefs.GetUserHash(), 16));

		//eWombat [SNAFU][TPT]
		m_SnafuGroupBox.SetWindowText(GetMaellaResString(IDS_PPG_SNAFUGROUP));
		m_iSnafu.SetWindowText(GetMaellaResString(IDS_PPG_PHOENIX_SNAFU));
		m_iAntiCreditTheft.SetWindowText(GetMaellaResString(IDS_PPG_PHOENIX_ACT));
		m_iAntiFriendshare.SetWindowText(GetMaellaResString(IDS_PPG_PHOENIX_FRIENDSHARE));
		//eWombat [SNAFU][TPT]


		// SERVER
		m_XSCheck.SetWindowText(GetMaellaResString(IDS_PPG_MAELLA_XS_CHECK));
		m_reaskSourceAfterIPChangeCheck.SetWindowText(GetMaellaResString(IDS_PPG_MAELLA_REASK_SOURCE_AFTER_IP_CHANGE_CHECK));

		// STATSSETUPINFO
		{   // zoom
			m_zoomGroupBox.SetWindowText(GetResString(IDS_GRAPHS));
			CString text;
			text.Format(GetMaellaResString(IDS_PPG_MAELLA_ZOOM_STATIC02), m_zoomSlider.GetPos());
			m_zoomStatic.SetWindowText(text);
		}
		{   // Datarate
			m_sampleRateGroupBox.SetWindowText(GetMaellaResString(IDS_PPG_MAELLA_SAMPLERATE_STATIC01));
			int position = m_sampleRateSlider.GetPos();
			CString text;
			if(position == 1)
				text = GetMaellaResString(IDS_PPG_MAELLA_SAMPLERATE_STATIC02a);
			else
				text.Format(GetMaellaResString(IDS_PPG_MAELLA_SAMPLERATE_STATIC02b), position);
			m_sampleRateStatic.SetWindowText(text);
		}

		// TWEAK
		m_filterVerboseGroupbox.SetWindowText(GetMaellaResString(IDS_PPG_MAELLA_FILTER_STATIC) + GetResString(IDS_VERBOSE));
		m_filterVerboseCheck01.SetWindowText(GetMaellaResString(IDS_PPG_MAELLA_FILTER_CHECK01));
		//m_filterVerboseCheck04.SetWindowText(GetMaellaResString(IDS_PPG_MAELLA_FILTER_CHECK04));
		m_filterVerboseCheck05.SetWindowText(GetMaellaResString(IDS_PPG_MAELLA_FILTER_CHECK05));
		m_filterVerboseCheck06.SetWindowText(GetMaellaResString(IDS_PPG_MAELLA_FILTER_CHECK06));
		m_filterVerboseCheck07.SetWindowText(GetMaellaResString(IDS_PPG_MAELLA_FILTER_CHECK07));
		m_filterVerboseCheck08.SetWindowText(GetMaellaResString(IDS_PPG_MAELLA_FILTER_CHECK08));
		m_filterVerboseCheck09.SetWindowText(GetMaellaResString(IDS_PPG_MAELLA_FILTER_CHECK09)); // [TPT] - Filter own messages
		m_filterVerboseCheck10.SetWindowText(GetMaellaResString(IDS_PPG_MAELLA_FILTER_CHECK10)); // [TPT] - Filter Handshake messages

		// FILES
		m_multiQueueGroupBox.SetWindowText(GetMaellaResString(IDS_PPG_MAELLA_MULTI_QUEUE_STATIC));
		m_multiQueueCheck01.SetWindowText(GetMaellaResString(IDS_PPG_MAELLA_MULTI_QUEUE_CHECK01));
		m_multiQueueCheck02.SetWindowText(GetMaellaResString(IDS_PPG_MAELLA_MULTI_QUEUE_CHECK02));

		m_A4AFBox.SetWindowText(GetMaellaResString(IDS_PPG_MAELLA_A4AF_STATIC));
		m_A4AFCheck.SetWindowText(GetMaellaResString(IDS_PPG_MAELLA_A4AF_CHECK));

        m_newUploadSlotSharpingCheck.SetWindowText(GetMaellaResString(IDS_PPG_MAELLA_NUSS_CHECK01));

		// Maella -MiniDump/CrashRpt-
		m_miniDumpStatic.SetWindowText(GetMaellaResString(IDS_PPG_MAELLA_MINIDUMP_STATIC));
		// Maella end
	}
}

void CPPgMaella::InitTab(){
	// Clear all to be sure
	m_tabCtr.DeleteAllItems();
	
	// Change style
	// Remark: It seems that the multi-row can not be activated with the properties
	m_tabCtr.ModifyStyle(0, TCS_MULTILINE);

	// Add all items with icon (connection, tweak, etc...)
	m_tabCtr.SetImageList(&m_imageList);
	m_tabCtr.InsertItem(TCIF_TEXT | TCIF_IMAGE | TCIF_PARAM, CONNECTION, GetResString(IDS_PW_CONNECTION), 2, (LPARAM)CONNECTION); 
	m_tabCtr.InsertItem(TCIF_TEXT | TCIF_IMAGE | TCIF_PARAM, SERVER, GetResString(IDS_PW_SERVER), 4, (LPARAM)SERVER); 
	m_tabCtr.InsertItem(TCIF_TEXT | TCIF_IMAGE | TCIF_PARAM, FILES, GetResString(IDS_FILES), 6, (LPARAM)FILES); 
	m_tabCtr.InsertItem(TCIF_TEXT | TCIF_IMAGE | TCIF_PARAM, STATSSETUPINFO, GetResString(IDS_STATSSETUPINFO), 7, (LPARAM)STATSSETUPINFO); 
	m_tabCtr.InsertItem(TCIF_TEXT | TCIF_IMAGE | TCIF_PARAM, SECURITY, GetResString(IDS_SECURITY), 10, (LPARAM)SECURITY); 
	m_tabCtr.InsertItem(TCIF_TEXT | TCIF_IMAGE | TCIF_PARAM, TWEAK, GetResString(IDS_PW_TWEAK), 11, (LPARAM)TWEAK);
}

void CPPgMaella::InitControl(){
	// Remark: don't use the dialog editor => avoid to merge rc

	// Retrieve the bottom of the tab's header
	RECT rect1;
	RECT rect2;
	m_tabCtr.GetWindowRect(&rect1);
	ScreenToClient(&rect1);
	m_tabCtr.GetItemRect(m_tabCtr.GetItemCount() - 1 , &rect2);
	const int top = rect1.top + (rect2.bottom - rect2.top + 1) * m_tabCtr.GetRowCount() + 10;
	const int right = rect1.left + 10;
	const int bottom = rect1.bottom;

	// CONNECTION
		// Maella -Overhead compensation (pseudo full rate control)-
		m_compOverheadCheck.CreateEx(0, _T("BUTTON"), "", 
									 WS_CHILD /*| WS_VISIBLE*/ | WS_TABSTOP |
									 BS_AUTOCHECKBOX, 
									 CRect(right, top+20, right+300, top+20+20), this, IDC_PPG_MAELLA_COMPENSATEOVERHEAD);
		m_compOverheadCheck.SetFont(GetFont());

		// Maella -MTU Configuration-
		m_MTUEdit.CreateEx(WS_EX_CLIENTEDGE, _T("EDIT"), "", 
						WS_CHILD /*| WS_VISIBLE*/ | WS_TABSTOP | WS_BORDER |
						ES_RIGHT | ES_AUTOHSCROLL | ES_NUMBER, 
						CRect(right, top+20+30, right+40, top+20+30+20), this, IDC_PPG_MAELLA_MTU_EDIT);
		m_MTUEdit.SetFont(GetFont());
		m_MTUEdit.SetLimitText(4);

		m_MTUStatic.CreateEx(0, _T("STATIC"), "", 
							WS_CHILD /*| WS_VISIBLE*/, 
							CRect(right+45, top+20+30+3, right+45+260, top+20+30+3+20), this, IDC_PPG_MAELLA_MTU_STATIC);
		m_MTUStatic.SetFont(GetFont());

		// Maella -Minimum Upload Slot-
		m_minSlotEdit.CreateEx(WS_EX_CLIENTEDGE, _T("EDIT"), "", 
							WS_CHILD /*| WS_VISIBLE*/ | WS_TABSTOP | WS_BORDER |
							ES_RIGHT | ES_AUTOHSCROLL | ES_NUMBER, 
							CRect(right, top+20+60, right+40, top+20+60+20), this, IDC_PPG_MAELLA_MIN_SLOT_EDIT);
		m_minSlotEdit.SetFont(GetFont());
		m_minSlotEdit.SetLimitText(1);

		m_minSlotStatic.CreateEx(0, _T("STATIC"), "", 
								WS_CHILD /*| WS_VISIBLE*/, 
								CRect(right+45, top+20+60+3, right+45+260, top+20+60+3+20), this, IDC_PPG_MAELLA_MIN_SLOT_STATIC);
		m_minSlotStatic.SetFont(GetFont());

		// Maella -Minimum Upload Slot-
		m_sndSocketSizeEdit.CreateEx(WS_EX_CLIENTEDGE, _T("EDIT"), "", 
							WS_CHILD /*| WS_VISIBLE*/ | WS_TABSTOP | WS_BORDER |
							ES_RIGHT | ES_AUTOHSCROLL | ES_NUMBER, 
							CRect(right, top+20+90, right+40, top+20+90+20), this, IDC_PPG_MAELLA_SND_SOCKET_SIZE_EDIT);
		m_sndSocketSizeEdit.SetFont(GetFont());
		m_sndSocketSizeEdit.SetLimitText(4);

		m_sndSocketSizeStatic.CreateEx(0, _T("STATIC"), "", 
								WS_CHILD /*| WS_VISIBLE*/, 
								CRect(right+45, top+20+90-3, right+45+260, top+20+90+3+20), this, IDC_PPG_MAELLA_SND_SOCKET_SIZE_STATIC);
		m_sndSocketSizeStatic.SetFont(GetFont());

		m_NAFCGroupBox.CreateEx(0, _T("BUTTON"), "", 
							   WS_CHILD /*| WS_VISIBLE*/ | WS_TABSTOP |
							   BS_GROUPBOX,
							   CRect(right, top+20+120, right+300, top+20+120+75), this, IDC_PPG_MAELLA_NAFC_STATIC01);
		m_NAFCGroupBox.SetFont(GetFont());

		m_NAFCCheck01.CreateEx(0, _T("BUTTON"), "", 
							  WS_CHILD /*| WS_VISIBLE*/ | WS_TABSTOP |
							  BS_AUTOCHECKBOX, 
							  CRect(right+10, top+20+120+20, right+295, top+20+120+20+20), this, IDC_PPG_MAELLA_NAFC_CHECK01);
		m_NAFCCheck01.SetFont(GetFont());

		m_NAFCEdit.CreateEx(WS_EX_CLIENTEDGE, _T("EDIT"), "", 
							WS_CHILD /*| WS_VISIBLE*/ | WS_TABSTOP | WS_BORDER |
							ES_RIGHT | ES_AUTOHSCROLL, 
  							CRect(right+10, top+20+120+3+40, right+10+45, top+20+120+3+40+20), this, IDC_PPG_MAELLA_NAFC_EDIT);
		m_NAFCEdit.SetFont(GetFont());
		m_sndSocketSizeEdit.SetLimitText(5);

		m_NAFCStatic.CreateEx(0, _T("STATIC"), "", 
							  WS_CHILD /*| WS_VISIBLE*/,  
							  CRect(right+10+40+10, top+20+120+6+40, right+175, top+20+120+6+40+20), this, IDC_PPG_MAELLA_NAFC_STATIC02);
		m_NAFCStatic.SetFont(GetFont());

		m_NAFCCheck02.CreateEx(0, _T("BUTTON"), "", 
							  WS_CHILD /*| WS_VISIBLE*/ | WS_TABSTOP |
							  BS_AUTOCHECKBOX, 
							  CRect(right+10+175, top+20+120+3+40, right+295, top+20+120+3+40+20), this, IDC_PPG_MAELLA_NAFC_CHECK02);
		m_NAFCCheck02.SetFont(GetFont());


		m_newUploadSlotSharpingCheck.CreateEx(0, _T("BUTTON"), "", 
						                      WS_CHILD /*| WS_VISIBLE*/ | WS_TABSTOP |
						                      BS_AUTOCHECKBOX, 
						                      CRect(right, top+20+120+75+20, right+300, top+20+120+75+20+20), this, IDC_PPG_MAELLA_NUSS_CHECK01);
		m_newUploadSlotSharpingCheck.SetFont(GetFont());

		m_iCumulateBW.CreateEx(0, _T("BUTTON"), "", 
						                      WS_CHILD /*| WS_VISIBLE*/ | WS_TABSTOP |
						                      BS_AUTOCHECKBOX, 
						                      CRect(right, top+20+120+75+20+20, right+300, top+20+120+75+20+20+20), this, IDC_PPG_PHOENIX_CUMULATEBW);
		m_iCumulateBW.SetFont(GetFont());

		m_connectionStatic.CreateEx(0, _T("STATIC"), "", 
								    WS_CHILD /*| WS_VISIBLE*/,
								    CRect(right, bottom-40, right+295, bottom-10), this, IDC_PPG_MAELLA_CONNECTION_STATIC);
		m_connectionStatic.SetFont(GetFont());



	// SECURITY
		// Maella -Defeat 0-filled Part Senders- (Idea of xrmb)
		m_corruptionGroupBox.CreateEx(0, _T("BUTTON"), "", 
									  WS_CHILD /*| WS_VISIBLE*/ | WS_TABSTOP |
									  BS_GROUPBOX,
									  CRect(right, top+20, right+300, top+20+70), this, IDC_PPG_MAELLA_CORRUPTION_STATIC);
		m_corruptionGroupBox.SetFont(GetFont());

		m_corruptionCheck.CreateEx(0, _T("BUTTON"), "", 
								   WS_CHILD /*| WS_VISIBLE*/ | WS_TABSTOP |
								   BS_AUTOCHECKBOX, 
								   CRect(right+10, top+20+20, right+10+280, top+20+20+20), this, IDC_PPG_MAELLA_CORRUPTION_CHECK);
		m_corruptionCheck.SetFont(GetFont());

		m_skipCorruptionCDCheck.CreateEx(0, _T("BUTTON"), "", 
										 WS_CHILD /*| WS_VISIBLE*/ | WS_TABSTOP |
										 BS_AUTOCHECKBOX, 
										 CRect(right+10+10, top+20+40, right+10+10+270, top+20+40+20), this, IDC_PPG_MAELLA_SKIP_CORRUPTION_CD_CHECK);
		m_skipCorruptionCDCheck.SetFont(GetFont());

		//eWombat [SNAFU][TPT]
		m_SnafuGroupBox.CreateEx(0, _T("BUTTON"), "", 
									WS_CHILD /*| WS_VISIBLE*/ | WS_TABSTOP |
									BS_GROUPBOX,
									CRect(right, top+20+190, right+300, top+20+190+90), this, IDC_PPG_SNAFU);
		m_SnafuGroupBox.SetFont(GetFont());

		m_iSnafu.CreateEx(0, _T("BUTTON"), "", 
									 WS_CHILD /*| WS_VISIBLE*/ | WS_TABSTOP |
									 BS_AUTOCHECKBOX, 
									 CRect(right+10, top+20+190+20, right+295, top+20+190+20+20), this, IDC_PPG_PHOENIX_SNAFU_CHECK);
		m_iSnafu.SetFont(GetFont());
		m_iAntiCreditTheft.CreateEx(0, _T("BUTTON"), "", 
									 WS_CHILD /*| WS_VISIBLE*/ | WS_TABSTOP |
									 BS_AUTOCHECKBOX, 
									 CRect(right+10, top+20+190+40, right+295, top+20+190+40+20), this, IDC_PPG_PHOENIX_ACT_CHECK);
		m_iAntiCreditTheft.SetFont(GetFont());
		m_iAntiFriendshare.CreateEx(0, _T("BUTTON"), "", 
									 WS_CHILD /*| WS_VISIBLE*/ | WS_TABSTOP |
									 BS_AUTOCHECKBOX, 
									 CRect(right+10, top+20+190+60, right+295, top+20+190+60+20), this, IDC_PPG_PHOENIX_FRIENDSHARE_CHECK);
		m_iAntiFriendshare.SetFont(GetFont());
		//eWombat [SNAFU][TPT] END

		m_userHashStatic.CreateEx(0, _T("STATIC"), "", 
								  WS_CHILD /*| WS_VISIBLE*/,
								  CRect(right, bottom-35, right+80, bottom-10), this, IDC_PPG_MAELLA_USERHASH_STATIC);
		m_userHashStatic.SetFont(GetFont());

		m_userHashEdit.CreateEx(0, _T("EDIT"), "", 
								WS_CHILD /*| WS_VISIBLE*/ | WS_TABSTOP |
								ES_LEFT | ES_AUTOHSCROLL | ES_READONLY , 
								CRect(right+85, bottom-30, right+295, bottom-10), this, IDC_PPG_MAELLA_USERHASH_EDIT);
		m_userHashEdit.SetFont(GetFont());

	// STATSSETUPINFO
		// Maella -Graph: display zoom-
		m_zoomGroupBox.CreateEx(0, _T("BUTTON"), "", 
								WS_CHILD /*| WS_VISIBLE*/ | WS_TABSTOP |
								BS_GROUPBOX,
								CRect(right, top+20, right+300, top+20+75), this, IDC_PPG_MAELLA_ZOOM_STATIC01);
		m_zoomGroupBox.SetFont(GetFont());

		m_zoomStatic.CreateEx(0, _T("STATIC"), "", 
							  WS_CHILD /*| WS_VISIBLE*/,
							  CRect(right+10, top+20+20, right+295, top+20+20+20), this, IDC_PPG_MAELLA_ZOOM_STATIC02);
		m_zoomStatic.SetFont(GetFont());

		m_zoomSlider.CreateEx(WS_EX_STATICEDGE,
							  WS_CHILD /*| WS_VISIBLE*/ | WS_TABSTOP | WS_BORDER |
							  TBS_TOOLTIPS | TBS_BOTH | TBS_HORZ | TBS_NOTICKS,
							  CRect(right+10, top+20+40, right+290, top+20+40+20), this, IDC_PPG_MAELLA_ZOOM_SLIDER);
		m_zoomSlider.SetFont(GetFont());
		m_zoomSlider.SetRange(1, 10);

		// Maella -Accurate measure of bandwidth: eDonkey data + control, network adapter-
		m_sampleRateGroupBox.CreateEx(0, _T("BUTTON"), "", 
									  WS_CHILD /*| WS_VISIBLE*/ | WS_TABSTOP |
									  BS_GROUPBOX,
									  CRect(right, top+20+85, right+300, top+20+85+75), this, IDC_PPG_MAELLA_SAMPLERATE_STATIC01);
		m_sampleRateGroupBox.SetFont(GetFont());

		m_sampleRateStatic.CreateEx(0, _T("STATIC"), "", 
									WS_CHILD /*| WS_VISIBLE*/,
									CRect(right+10, top+20+85+20, right+295, top+20+85+20+20), this, IDC_PPG_MAELLA_SAMPLERATE_STATIC02);
		m_sampleRateStatic.SetFont(GetFont());

		m_sampleRateSlider.CreateEx(WS_EX_STATICEDGE,
									WS_CHILD /*| WS_VISIBLE*/ | WS_TABSTOP | WS_BORDER |
									TBS_TOOLTIPS | TBS_BOTH | TBS_HORZ | TBS_NOTICKS,
									CRect(right+10, top+20+85+40, right+290, top+20+85+40+20), this, IDC_PPG_MAELLA_SAMPLERATE_SLIDER);
		m_sampleRateSlider.SetFont(GetFont());
		m_sampleRateSlider.SetRange(1, 10);

	// SERVER
		// Maella -Enable/Disable source exchange in preference- (Tarod)
		m_XSCheck.CreateEx(0, _T("BUTTON"), "", 
						WS_CHILD /*| WS_VISIBLE*/ | WS_TABSTOP |
						BS_AUTOCHECKBOX, 
						CRect(right, top+20, right+300, top+20+20), this, IDC_PPG_MAELLA_XS_CHECK);
		m_XSCheck.SetFont(GetFont());

		m_reaskSourceAfterIPChangeCheck.CreateEx(0, _T("BUTTON"), "", 
												 WS_CHILD /*| WS_VISIBLE*/ | WS_TABSTOP |
												 BS_AUTOCHECKBOX, 
												 CRect(right, top+20+20, right+300, top+20+20+20), this, IDC_PPG_MAELLA_REASK_SOURCE_AFTER_IP_CHANGE_CHECK);
		m_reaskSourceAfterIPChangeCheck.SetFont(GetFont());

	// TWEAK
		// Maella -Filter verbose messages-
		m_filterVerboseGroupbox.CreateEx(0, _T("BUTTON"), "", 
										WS_CHILD /*| WS_VISIBLE*/ | WS_TABSTOP |
										BS_GROUPBOX,
										CRect(right, top+20, right+300, top+20+190), this, IDC_PPG_MAELLA_FILTER_STATIC);
		m_filterVerboseGroupbox.SetFont(GetFont());

		m_filterVerboseCheck01.CreateEx(0, _T("BUTTON"), "", 
										WS_CHILD /*| WS_VISIBLE*/ | WS_TABSTOP |
										BS_AUTOCHECKBOX, 
										CRect(right+10, top+20+20, right+295, top+20+20+20), this, IDC_PPG_MAELLA_FILTER_VERBOSE_CHECK01);
		m_filterVerboseCheck01.SetFont(GetFont());

		/*m_filterVerboseCheck04.CreateEx(0, _T("BUTTON"), "", 
										WS_CHILD /*| WS_VISIBLE*//* | WS_TABSTOP |
										BS_AUTOCHECKBOX, 
										CRect(right+10, top+20+40, right+295, top+20+40+20), this, IDC_PPG_MAELLA_FILTER_VERBOSE_CHECK04);
		m_filterVerboseCheck04.SetFont(GetFont());*/

		m_filterVerboseCheck05.CreateEx(0, _T("BUTTON"), "", 
										WS_CHILD /*| WS_VISIBLE*/ | WS_TABSTOP |
										BS_AUTOCHECKBOX, 
										CRect(right+10, top+20+60, right+295, top+20+60+20), this, IDC_PPG_MAELLA_FILTER_VERBOSE_CHECK05);
		m_filterVerboseCheck05.SetFont(GetFont());

		m_filterVerboseCheck06.CreateEx(0, _T("BUTTON"), "", 
										WS_CHILD /*| WS_VISIBLE*/ | WS_TABSTOP |
										BS_AUTOCHECKBOX, 
										CRect(right+10, top+20+80, right+295, top+20+80+20), this, IDC_PPG_MAELLA_FILTER_VERBOSE_CHECK06);
		m_filterVerboseCheck06.SetFont(GetFont());

		m_filterVerboseCheck07.CreateEx(0, _T("BUTTON"), "", 
										WS_CHILD /*| WS_VISIBLE*/ | WS_TABSTOP |
										BS_AUTOCHECKBOX, 
										CRect(right+10, top+20+100, right+295, top+20+100+20), this, IDC_PPG_MAELLA_FILTER_VERBOSE_CHECK07);
		m_filterVerboseCheck07.SetFont(GetFont());

		m_filterVerboseCheck08.CreateEx(0, _T("BUTTON"), "", 
										WS_CHILD /*| WS_VISIBLE*/ | WS_TABSTOP |
										BS_AUTOCHECKBOX, 
										CRect(right+10, top+20+120, right+295, top+20+120+20), this, IDC_PPG_MAELLA_FILTER_VERBOSE_CHECK08);
		m_filterVerboseCheck08.SetFont(GetFont());

		// [TPT] - Filter own messages
		m_filterVerboseCheck09.CreateEx(0, _T("BUTTON"), "", 
										WS_CHILD /*| WS_VISIBLE*/ | WS_TABSTOP |
										BS_AUTOCHECKBOX, 
										CRect(right+10, top+20+140, right+295, top+20+140+20), this, IDC_PPG_MAELLA_FILTER_VERBOSE_CHECK09);
		m_filterVerboseCheck09.SetFont(GetFont());

		// [TPT] - Filter Handshake messages
		m_filterVerboseCheck10.CreateEx(0, _T("BUTTON"), "", 
										WS_CHILD /*| WS_VISIBLE*/ | WS_TABSTOP |
										BS_AUTOCHECKBOX, 
										CRect(right+10, top+20+160, right+295, top+20+160+20), this, IDC_PPG_MAELLA_FILTER_VERBOSE_CHECK10);
		m_filterVerboseCheck10.SetFont(GetFont());

	// FILES
		// Maella -Filter verbose messages-
		m_multiQueueGroupBox.CreateEx(0, _T("BUTTON"), "", 
									  WS_CHILD /*| WS_VISIBLE*/ | WS_TABSTOP |
									  BS_GROUPBOX,
									  CRect(right, top+20, right+300, top+20+75), this, IDC_PPG_MAELLA_MULTI_QUEUE_STATIC);
		m_multiQueueGroupBox.SetFont(GetFont());

		m_multiQueueCheck01.CreateEx(0, _T("BUTTON"), "", 
									 WS_CHILD /*| WS_VISIBLE*/ | WS_TABSTOP |
									 BS_AUTOCHECKBOX, 
									 CRect(right+10, top+20+20, right+295, top+20+20+20), this, IDC_PPG_MAELLA_MULTI_QUEUE_CHECK01);
		m_multiQueueCheck01.SetFont(GetFont());

		m_multiQueueCheck02.CreateEx(0, _T("BUTTON"), "", 
									 WS_CHILD /*| WS_VISIBLE*/ | WS_TABSTOP |
									 BS_AUTOCHECKBOX, 
									 CRect(right+10+10, top+20+40, right+295, top+20+40+20), this, IDC_PPG_MAELLA_MULTI_QUEUE_CHECK02);
		m_multiQueueCheck02.SetFont(GetFont());

		m_A4AFBox.CreateEx(0, _T("BUTTON"), "", 
						   WS_CHILD /*| WS_VISIBLE*/ | WS_TABSTOP |
						   BS_GROUPBOX,
						   CRect(right, top+20+85, right+300, top+20+85+50), this, IDC_PPG_MAELLA_A4AF_STATIC);
		m_A4AFBox.SetFont(GetFont());

		m_A4AFCheck.CreateEx(0, _T("BUTTON"), "", 
						   WS_CHILD /*| WS_VISIBLE*/ | WS_TABSTOP |
						   BS_AUTOCHECKBOX, 
						   CRect(right+10, top+20+85+20, right+295, top+20+85+35), this, IDC_PPG_MAELLA_A4AF_CHECK);
		m_A4AFCheck.SetFont(GetFont());



		// Maella -MiniDump/CrashRpt-
		m_miniDumpStatic.CreateEx(0, _T("STATIC"), "", 
								  WS_CHILD /*| WS_VISIBLE*/,
								  CRect(right, bottom-30, right+295, bottom-10), this, IDC_PPG_MAELLA_MINIDUMP_STATIC);
		m_miniDumpStatic.SetFont(GetFont());
		// Maella end
}

void CPPgMaella::OnTabSelectionChange(NMHDR *pNMHDR, LRESULT *pResult)
{
	// Retrieve tab to display
	TCITEM tabCtrlItem; 
	tabCtrlItem.mask = TCIF_PARAM;
	if(m_tabCtr.GetItem(m_tabCtr.GetCurSel(), &tabCtrlItem) == TRUE){
		SetTab(static_cast<eTab>(tabCtrlItem.lParam));
	}

	*pResult = 0;
}

void CPPgMaella::OnCorruptionCheckChange(){
	// Grey "Skip test for CD-Image (e.g. .bin, .nrg)"
	m_skipCorruptionCDCheck.EnableWindow(m_corruptionCheck.GetCheck() != BST_UNCHECKED);

	SetModified(TRUE);
}

void CPPgMaella::OnMultiQueueChange(){
	m_multiQueueCheck02.EnableWindow(m_multiQueueCheck01.GetCheck() != BST_UNCHECKED);

	SetModified(TRUE);
}

void CPPgMaella::OnNAFCChange(){
	m_NAFCCheck02.EnableWindow(m_NAFCCheck01.GetCheck() == BST_CHECKED);	
	m_NAFCEdit.EnableWindow(theApp.pBandWidthControl->IsNAFCAvailable() == true && m_NAFCCheck01.GetCheck() != BST_UNCHECKED);	
	SetModified(TRUE);
}

void CPPgMaella::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	SetModified(TRUE);
	
	CSliderCtrl* slider =(CSliderCtrl*)pScrollBar;
	int position = slider->GetPos();

	if(slider == &m_zoomSlider){
		CString text;
		text.Format(GetMaellaResString(IDS_PPG_MAELLA_ZOOM_STATIC02), position);
		m_zoomStatic.SetWindowText(text);
	}
	else if(slider == &m_sampleRateSlider){
		CString text;
		if(position == 1)
			text = GetMaellaResString(IDS_PPG_MAELLA_SAMPLERATE_STATIC02a);
		else
			text.Format(GetMaellaResString(IDS_PPG_MAELLA_SAMPLERATE_STATIC02b), position);
		m_sampleRateStatic.SetWindowText(text);
	}

	CPropertyPage::OnHScroll(nSBCode, nPos, pScrollBar);
}

void CPPgMaella::SetTab(eTab tab){
	if(m_currentTab != tab){
		// Hide all control
		switch(m_currentTab){
			case CONNECTION:
				// Connection
				m_compOverheadCheck.ShowWindow(SW_HIDE);
				m_compOverheadCheck.EnableWindow(FALSE);

				m_MTUEdit.ShowWindow(SW_HIDE);
				m_MTUEdit.EnableWindow(FALSE);
				m_MTUStatic.ShowWindow(SW_HIDE);
				m_MTUStatic.EnableWindow(FALSE);

				m_minSlotEdit.ShowWindow(SW_HIDE);
				m_minSlotEdit.EnableWindow(FALSE);
				m_minSlotStatic.ShowWindow(SW_HIDE);
				m_minSlotStatic.EnableWindow(FALSE);

				m_sndSocketSizeEdit.ShowWindow(SW_HIDE);
				m_sndSocketSizeEdit.EnableWindow(FALSE);
				m_sndSocketSizeStatic.ShowWindow(SW_HIDE);
				m_sndSocketSizeStatic.EnableWindow(FALSE);

				m_NAFCGroupBox.ShowWindow(SW_HIDE);
				m_NAFCGroupBox.EnableWindow(FALSE);
				m_NAFCStatic.ShowWindow(SW_HIDE);
				m_NAFCStatic.EnableWindow(FALSE);
				m_NAFCCheck01.ShowWindow(SW_HIDE);
				m_NAFCCheck01.EnableWindow(FALSE);
				m_NAFCCheck02.ShowWindow(SW_HIDE);
				m_NAFCCheck02.EnableWindow(FALSE);
				m_NAFCEdit.ShowWindow(SW_HIDE);
				m_NAFCEdit.EnableWindow(FALSE);

				m_connectionStatic.ShowWindow(SW_HIDE);
				m_connectionStatic.EnableWindow(FALSE);
				//[TPT]-Cumulate Bandwidth
				m_iCumulateBW.ShowWindow(SW_HIDE);
				m_iCumulateBW.EnableWindow(FALSE);
				m_newUploadSlotSharpingCheck.ShowWindow(SW_HIDE);
				m_newUploadSlotSharpingCheck.EnableWindow(FALSE);


				break;

			case SECURITY:
				m_corruptionGroupBox.ShowWindow(SW_HIDE);
				m_corruptionGroupBox.EnableWindow(FALSE);
				m_corruptionCheck.ShowWindow(SW_HIDE);
				m_corruptionCheck.EnableWindow(FALSE);
				m_skipCorruptionCDCheck.ShowWindow(SW_HIDE);
				m_skipCorruptionCDCheck.EnableWindow(FALSE);

				//eWombat [SNAFU][TPT]
				m_SnafuGroupBox.ShowWindow(SW_HIDE);
				m_SnafuGroupBox.EnableWindow(FALSE);
				m_iSnafu.ShowWindow(SW_HIDE);
				m_iSnafu.EnableWindow(FALSE);
				m_iAntiCreditTheft.ShowWindow(SW_HIDE);
				m_iAntiCreditTheft.EnableWindow(FALSE);	
				m_iAntiFriendshare.ShowWindow(SW_HIDE);
				m_iAntiFriendshare.EnableWindow(FALSE);
				//eWombat [SNAFU][TPT]

				m_userHashStatic.ShowWindow(SW_HIDE);
				m_userHashStatic.EnableWindow(FALSE);
				m_userHashEdit.ShowWindow(SW_HIDE);
				m_userHashEdit.EnableWindow(FALSE);
				break;

			case STATSSETUPINFO:
				m_zoomGroupBox.ShowWindow(SW_HIDE);
				m_zoomGroupBox.EnableWindow(FALSE);
				m_zoomStatic.ShowWindow(SW_HIDE);
				m_zoomStatic.EnableWindow(FALSE);
				m_zoomSlider.ShowWindow(SW_HIDE);
				m_zoomSlider.EnableWindow(FALSE);

				m_sampleRateGroupBox.ShowWindow(SW_HIDE);
				m_sampleRateGroupBox.EnableWindow(FALSE);
				m_sampleRateStatic.ShowWindow(SW_HIDE);
				m_sampleRateStatic.EnableWindow(FALSE);
				m_sampleRateSlider.ShowWindow(SW_HIDE);
				m_sampleRateSlider.EnableWindow(FALSE);
				break;

			case SERVER:
				m_XSCheck.ShowWindow(SW_HIDE);
				m_XSCheck.EnableWindow(FALSE);

				m_reaskSourceAfterIPChangeCheck.ShowWindow(SW_HIDE);
				m_reaskSourceAfterIPChangeCheck.EnableWindow(FALSE);
				break;

			case FILES:
				m_multiQueueGroupBox.ShowWindow(SW_HIDE);
				m_multiQueueGroupBox.EnableWindow(FALSE);
				m_multiQueueCheck01.ShowWindow(SW_HIDE);
				m_multiQueueCheck01.EnableWindow(FALSE);
				m_multiQueueCheck02.ShowWindow(SW_HIDE);
				m_multiQueueCheck02.EnableWindow(FALSE);

				m_A4AFBox.ShowWindow(SW_HIDE);
				m_A4AFBox.EnableWindow(FALSE);
				m_A4AFCheck.ShowWindow(SW_HIDE);
				m_A4AFCheck.EnableWindow(FALSE);

				break;

			case TWEAK:
				m_filterVerboseGroupbox.ShowWindow(SW_HIDE);
				m_filterVerboseGroupbox.EnableWindow(FALSE);
				m_filterVerboseCheck01.ShowWindow(SW_HIDE);
				m_filterVerboseCheck01.EnableWindow(FALSE);								
				//m_filterVerboseCheck04.ShowWindow(SW_HIDE);
				//m_filterVerboseCheck04.EnableWindow(FALSE);
				m_filterVerboseCheck05.ShowWindow(SW_HIDE);
				m_filterVerboseCheck05.EnableWindow(FALSE);
				m_filterVerboseCheck06.ShowWindow(SW_HIDE);
				m_filterVerboseCheck06.EnableWindow(FALSE);
				m_filterVerboseCheck07.ShowWindow(SW_HIDE);
				m_filterVerboseCheck07.EnableWindow(FALSE);
				m_filterVerboseCheck08.ShowWindow(SW_HIDE);
				m_filterVerboseCheck08.EnableWindow(FALSE);
				// [TPT] - Filter own messages
				m_filterVerboseCheck09.ShowWindow(SW_HIDE);
				m_filterVerboseCheck09.EnableWindow(FALSE);
				// [TPT] - Filter Handshake messages
				m_filterVerboseCheck10.ShowWindow(SW_HIDE);
				m_filterVerboseCheck10.EnableWindow(FALSE);

				// Maella -MiniDump/CrashRpt-
				m_miniDumpStatic.ShowWindow(SW_HIDE);
				m_miniDumpStatic.EnableWindow(FALSE);
				// Maella end
				break;
		}

		// Show new controls
		m_currentTab = tab;
		switch(m_currentTab){
			case CONNECTION:
				// Connection
				m_compOverheadCheck.ShowWindow(SW_SHOW);
				m_compOverheadCheck.EnableWindow(TRUE);

				m_MTUEdit.ShowWindow(SW_SHOW);
				m_MTUEdit.EnableWindow(TRUE);
				m_MTUStatic.ShowWindow(SW_SHOW);
				m_MTUStatic.EnableWindow(TRUE);

				m_minSlotEdit.ShowWindow(SW_SHOW);
				m_minSlotEdit.EnableWindow(TRUE);
				m_minSlotStatic.ShowWindow(SW_SHOW);
				m_minSlotStatic.EnableWindow(TRUE);

				m_sndSocketSizeEdit.ShowWindow(SW_SHOW);
				m_sndSocketSizeEdit.EnableWindow(TRUE);
				m_sndSocketSizeStatic.ShowWindow(SW_SHOW);
				m_sndSocketSizeStatic.EnableWindow(TRUE);

				m_NAFCGroupBox.ShowWindow(SW_SHOW);
				m_NAFCStatic.ShowWindow(SW_SHOW);
				m_NAFCCheck01.ShowWindow(SW_SHOW);
				m_NAFCCheck02.ShowWindow(SW_SHOW);
				m_NAFCEdit.ShowWindow(SW_SHOW);
				if(theApp.pBandWidthControl->IsNAFCAvailable() == true){
					m_NAFCGroupBox.EnableWindow(TRUE);
					m_NAFCStatic.EnableWindow(TRUE);
					m_NAFCCheck01.EnableWindow(theApp.pBandWidthControl->IsNAFCAvailable() == true);
					m_NAFCCheck02.EnableWindow(m_NAFCCheck01.GetCheck() == BST_CHECKED);
					m_NAFCEdit.EnableWindow(m_NAFCCheck01.GetCheck() == BST_CHECKED);
				}

				m_connectionStatic.ShowWindow(SW_SHOW);
				m_connectionStatic.EnableWindow(TRUE);
				//[TPT]-Cumulate Bandwidth
				m_iCumulateBW.ShowWindow(SW_SHOW);
				m_iCumulateBW.EnableWindow(TRUE);
				m_newUploadSlotSharpingCheck.ShowWindow(SW_SHOW);
				m_newUploadSlotSharpingCheck.EnableWindow(TRUE);

				break;

			case SECURITY:
				m_corruptionGroupBox.ShowWindow(SW_SHOW);
				m_corruptionGroupBox.EnableWindow(TRUE);
				m_corruptionCheck.ShowWindow(SW_SHOW);
				m_corruptionCheck.EnableWindow(TRUE);
				m_skipCorruptionCDCheck.ShowWindow(SW_SHOW);
				m_skipCorruptionCDCheck.EnableWindow(m_corruptionCheck.GetCheck() != BST_UNCHECKED);

				//eWombat [SNAFU][TPT]
				m_SnafuGroupBox.ShowWindow(SW_SHOW);
				m_SnafuGroupBox.EnableWindow(TRUE);
				m_iSnafu.ShowWindow(SW_SHOW);
				m_iSnafu.EnableWindow(TRUE);
				m_iAntiCreditTheft.ShowWindow(SW_SHOW);
				m_iAntiCreditTheft.EnableWindow(TRUE);	
				m_iAntiFriendshare.ShowWindow(SW_SHOW);
				m_iAntiFriendshare.EnableWindow(TRUE);
				//eWombat [SNAFU][TPT]


				m_userHashStatic.ShowWindow(SW_SHOW);
				m_userHashStatic.EnableWindow(TRUE);
				m_userHashEdit.ShowWindow(SW_SHOW);
				m_userHashEdit.EnableWindow(TRUE);
				break;

			case STATSSETUPINFO:
				m_zoomGroupBox.ShowWindow(SW_SHOW);
				m_zoomGroupBox.EnableWindow(TRUE);
				m_zoomStatic.ShowWindow(SW_SHOW);
				m_zoomStatic.EnableWindow(TRUE);
				m_zoomSlider.ShowWindow(SW_SHOW);
				m_zoomSlider.EnableWindow(TRUE);

				m_sampleRateGroupBox.ShowWindow(SW_SHOW);
				m_sampleRateGroupBox.EnableWindow(TRUE);
				m_sampleRateStatic.ShowWindow(SW_SHOW);
				m_sampleRateStatic.EnableWindow(TRUE);
				m_sampleRateSlider.ShowWindow(SW_SHOW);
				m_sampleRateSlider.EnableWindow(TRUE);
				break;

			case SERVER:
				m_XSCheck.ShowWindow(SW_SHOW);
				m_XSCheck.EnableWindow(TRUE);

				m_reaskSourceAfterIPChangeCheck.ShowWindow(SW_SHOW);
				m_reaskSourceAfterIPChangeCheck.EnableWindow(TRUE);
				break;

			case FILES:
				m_multiQueueGroupBox.ShowWindow(SW_SHOW);
				m_multiQueueGroupBox.EnableWindow(TRUE);
				m_multiQueueCheck01.ShowWindow(SW_SHOW);
				m_multiQueueCheck01.EnableWindow(TRUE);
				m_multiQueueCheck02.ShowWindow(SW_SHOW);
				m_multiQueueCheck02.EnableWindow(m_multiQueueCheck01.GetCheck() != BST_UNCHECKED);

				m_A4AFBox.ShowWindow(SW_SHOW);
				m_A4AFBox.EnableWindow(TRUE);
				m_A4AFCheck.ShowWindow(SW_SHOW);
				m_A4AFCheck.EnableWindow(TRUE);

				break;

			case TWEAK:
				m_filterVerboseGroupbox.ShowWindow(SW_SHOW);
				m_filterVerboseGroupbox.EnableWindow(TRUE);
				m_filterVerboseCheck01.ShowWindow(SW_SHOW);
				m_filterVerboseCheck01.EnableWindow((thePrefs.GetVerbose() == false) ? FALSE : TRUE);								
				//m_filterVerboseCheck04.ShowWindow(SW_SHOW);
				//m_filterVerboseCheck04.EnableWindow((thePrefs.GetVerbose() == false) ? FALSE : TRUE);
				m_filterVerboseCheck05.ShowWindow(SW_SHOW);
				m_filterVerboseCheck05.EnableWindow((thePrefs.GetVerbose() == false) ? FALSE : TRUE);
				m_filterVerboseCheck06.ShowWindow(SW_SHOW);
				m_filterVerboseCheck06.EnableWindow((thePrefs.GetVerbose() == false) ? FALSE : TRUE);
				m_filterVerboseCheck07.ShowWindow(SW_SHOW);
				m_filterVerboseCheck07.EnableWindow((thePrefs.GetVerbose() == false) ? FALSE : TRUE);
				m_filterVerboseCheck08.ShowWindow(SW_SHOW);
				m_filterVerboseCheck08.EnableWindow((thePrefs.GetVerbose() == false) ? FALSE : TRUE);
				// [TPT] - Filter own messages
				m_filterVerboseCheck09.ShowWindow(SW_SHOW);
				m_filterVerboseCheck09.EnableWindow((thePrefs.GetVerbose() == false) ? FALSE : TRUE);
				// [TPT] - Filter own messages
				m_filterVerboseCheck10.ShowWindow(SW_SHOW);
				m_filterVerboseCheck10.EnableWindow((thePrefs.GetVerbose() == false) ? FALSE : TRUE);

				// Maella -MiniDump/CrashRpt-
				if(s_miniDump.IsMiniDumpActivated() == true){
					m_miniDumpStatic.ShowWindow(SW_SHOW);
					m_miniDumpStatic.EnableWindow(TRUE);
				}
				// Maella end
				break;
		}
	}
}