// PPgPhoenix1.cpp : implementation file
//

#include "stdafx.h"
#include "emule.h"
#include "PPgPhoenix1.h"
#include "preferences.h"
#include "PreferencesDlg.h"
#include "HttpDownloadDlg.h"
#include "BandwidthControl.h"
#include "EmuleDlg.h"
#include "SharedFilesWnd.h"
#include "TransferWnd.h"
#include "opcodes.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

// CPPgPhoenix1 dialog

IMPLEMENT_DYNAMIC(CPPgPhoenix1, CPreferencesPage) // [TPT] - SLUGFILLER: modelessDialogs
CPPgPhoenix1::CPPgPhoenix1()
	: CPreferencesPage(CPPgPhoenix1::IDD) // [TPT] - SLUGFILLER: modelessDialogs
{	

}

CPPgPhoenix1::~CPPgPhoenix1()
{
}

void CPPgPhoenix1::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_PPG_MAELLA_TAB, m_tabCtr);
}

BEGIN_MESSAGE_MAP(CPPgPhoenix1, CPreferencesPage) // [TPT] - SLUGFILLER: modelessDialogs
	// TAB control
	ON_NOTIFY(TCN_SELCHANGE, IDC_PPG_MAELLA_TAB, OnTabSelectionChange)

	//--------------------------------------------------------------BEGIN-

	//CONEXION -----------------------------------------------------------
	// Maella -Overhead compensation (pseudo full rate control)-
	ON_BN_CLICKED(IDC_PPG_MAELLA_COMPENSATEOVERHEAD, OnSettingsChange)
	// Maella -MTU Configuration-
	ON_EN_CHANGE(IDC_PPG_MAELLA_MTU_EDIT, OnSettingsChange) 
	// Maella -Send Socket Size-
	ON_EN_CHANGE(IDC_PPG_MAELLA_SND_SOCKET_SIZE_EDIT, OnSettingsChange) 
	// [TPT] - quick start
	ON_BN_CLICKED(IDC_PPG_PHOENIX_QUICKSTART, OnQuickStartChange)   	


	//SUBIDAS ------------------------------------------------------------
	// Maella -NAFC-	
	ON_EN_CHANGE(IDC_PPG_MAELLA_NAFC_EDIT, OnSettingsChange) 
	ON_BN_CLICKED(IDC_PPG_MAELLA_NAFC_CHECK01, OnNAFCChange) 
	ON_BN_CLICKED(IDC_PPG_MAELLA_NAFC_CHECK02, OnNAFCChange) 
	// Maella -Minimum Upload Slot-
	ON_EN_CHANGE(IDC_PPG_MAELLA_MIN_SLOT_EDIT, OnSettingsChange) 
	// Maella - New Upload Slot Sharping-
	ON_BN_CLICKED(IDC_PPG_MAELLA_NUSS_CHECK01, OnSettingsChange)
	//[TPT]-Cumulate Bandwidth
	ON_BN_CLICKED(IDC_PPG_PHOENIX_CUMULATEBW, OnSettingsChange) 


	//SERVIDOR -----------------------------------------------------------
	// Maella -Enable/Disable source exchange in preference- (Tarod)
	ON_BN_CLICKED(IDC_PPG_MAELLA_XS_CHECK, OnSettingsChange) 
	ON_BN_CLICKED(IDC_PPG_MAELLA_REASK_SOURCE_AFTER_IP_CHANGE_CHECK, OnSettingsChange) 

	//SEGURIDAD ----------------------------------------------------------
	// Maella -Defeat 0-filled Part Senders- (Idea of xrmb)
	ON_BN_CLICKED(IDC_PPG_MAELLA_CORRUPTION_CHECK, OnCorruptionCheckChange) 
	ON_BN_CLICKED(IDC_PPG_MAELLA_SKIP_CORRUPTION_CD_CHECK, OnSettingsChange) 
	//eWombat [SNAFU][TPT]begin
	ON_BN_CLICKED(IDC_PPG_PHOENIX_SNAFU_CHECK, OnSettingsChange) 
	ON_BN_CLICKED(IDC_PPG_PHOENIX_ACT_CHECK, OnSettingsChange) 
	ON_BN_CLICKED(IDC_PPG_PHOENIX_FRIENDSHARE_CHECK, OnSettingsChange) 
	//eWombat [SNAFU][TPT]end


	//LOG FILTERS --------------------------------------------------------
	// Maella -Filter verbose messages-
	ON_BN_CLICKED(IDC_PPG_MAELLA_FILTER_VERBOSE_CHECK01, OnSettingsChange)
	ON_BN_CLICKED(IDC_PPG_MAELLA_FILTER_VERBOSE_CHECK04, OnSettingsChange) 
	ON_BN_CLICKED(IDC_PPG_MAELLA_FILTER_VERBOSE_CHECK05, OnSettingsChange) 
	ON_BN_CLICKED(IDC_PPG_MAELLA_FILTER_VERBOSE_CHECK06, OnSettingsChange) 
	ON_BN_CLICKED(IDC_PPG_MAELLA_FILTER_VERBOSE_CHECK07, OnSettingsChange) 
	ON_BN_CLICKED(IDC_PPG_MAELLA_FILTER_VERBOSE_CHECK08, OnSettingsChange) 
	ON_BN_CLICKED(IDC_PPG_MAELLA_FILTER_VERBOSE_CHECK09, OnSettingsChange)  // [TPT] - Filter own messages
	ON_BN_CLICKED(IDC_PPG_MAELLA_FILTER_VERBOSE_CHECK10, OnSettingsChange)  // [TPT] - Filter Handshake messages

	//----------------------------------------------------------------END-

END_MESSAGE_MAP()

// CPPgPhoenix1 message handlers

BOOL CPPgPhoenix1::OnInitDialog()
{
	CPropertyPage::OnInitDialog();

	// Init the Tab control
	InitTab();

	// Create and Init all controls
	InitControl();

	// Set default tab
	m_currentTab = NONE;
	m_tabCtr.SetCurSel(0);
	SetTab(CONNECTION);//Tab x defecto Conexion

	// Load setting
	LoadSettings();
	Localize();

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

void CPPgPhoenix1::LoadSettings()
{

	//--------------------------------------------------------------BEGIN-

	//CONEXION -----------------------------------------------------------
	// Maella -Overhead compensation (pseudo full rate control)-
	m_compOverheadCheck.SetCheck((thePrefs.GetCompensateOverhead() == true) ? BST_CHECKED : BST_UNCHECKED);

	// Maella -MTU Configuration-
	{
		CString buffer;
		buffer.Format(_T("%u"), thePrefs.GetMTU());
		m_MTUEdit.SetWindowText(buffer);
	}
	// Maella -New bandwidth control-
	{
		CString buffer;
		buffer.Format(_T("%u"), thePrefs.GetSendSocketBufferSize());
		m_sndSocketSizeEdit.SetWindowText(buffer);
	}
	// [TPT] - quick start
	m_iQuickStart.SetCheck(thePrefs.GetQuickStart());
	{
		CString buffer;
		buffer.Format(_T("%u"), thePrefs.GetQuickStartMaxConPerFive());
		m_iMaxConnPerFive.EnableWindow(m_iQuickStart.GetCheck() == BST_CHECKED);		
		m_iMaxConnPerFive.SetWindowText(buffer);
		m_iMaxConnPerFiveStatic.EnableWindow(m_iQuickStart.GetCheck() == BST_CHECKED);
		m_iMaxConn.EnableWindow(m_iQuickStart.GetCheck() == BST_CHECKED);
		buffer.Format(_T("%u"), thePrefs.GetQuickStartMaxCon());
		m_iMaxConn.SetWindowText(buffer);
		m_iMaxConnStatic.EnableWindow(m_iQuickStart.GetCheck() == BST_CHECKED);
	}
	// [TPT] - quick start


	//SUBIDAS ------------------------------------------------------------
	// Maella -Network Adapter Feedback Control-
	m_NAFCCheck01.EnableWindow(theApp.pBandWidthControl->IsNAFCAvailable() == true);
	m_NAFCCheck01.SetCheck((thePrefs.GetNAFCEnable() == true) ? BST_CHECKED : BST_UNCHECKED);
	m_NAFCCheck02.EnableWindow(theApp.pBandWidthControl->IsNAFCAvailable() == true && m_NAFCCheck01.GetCheck() != BST_UNCHECKED);
	m_NAFCCheck02.SetCheck((thePrefs.GetNAFCFullControl() == true) ? BST_CHECKED : BST_UNCHECKED);
	{
		CString buffer;
		m_NAFCEdit.EnableWindow(m_NAFCCheck01.GetCheck() == BST_CHECKED);
		buffer.Format(_T("%.1f"), thePrefs.GetNAFCNetworkOut());
		m_NAFCEdit.SetWindowText(buffer);
	}
	// Maella -Minimum Upload Slot-
	{
		CString buffer;
		buffer.Format(_T("%u"), thePrefs.GetMinUploadSlot());
		m_minSlotEdit.SetWindowText(buffer);
	}
	//New Upload slot sharping
	m_newUploadSlotSharpingCheck.SetCheck((thePrefs.GetEnableNewUSS() == true) ? BST_CHECKED : BST_UNCHECKED);
	//[TPT]-Cumulate Bandwidth
	m_iCumulateBW.SetCheck(thePrefs.IsCumulateBandwidthEnabled());
	

	//SERVIDOR -----------------------------------------------------------
	// Maella -Enable/Disable source exchange in preference- (Tarod)
	m_XSCheck.SetCheck((thePrefs.GetDisabledXS() == true) ? BST_CHECKED : BST_UNCHECKED);
	// Maella -Reask sources after IP change- (idea Xman)
	m_reaskSourceAfterIPChangeCheck.SetCheck((thePrefs.GetReaskSourceAfterIPChange() != true) ? BST_CHECKED : BST_UNCHECKED); // [TPT]

	//SEGURIDAD ----------------------------------------------------------
	// Maella -Defeat 0-filled Part Senders- (Idea of xrmb)
	m_corruptionCheck.SetCheck((thePrefs.GetCorruptionTest() == true) ? BST_CHECKED : BST_UNCHECKED);
	m_skipCorruptionCDCheck.EnableWindow(m_corruptionCheck.GetCheck() != BST_UNCHECKED);
	m_skipCorruptionCDCheck.SetCheck((thePrefs.GetSkipCorruptionCDTest() == true) ? BST_CHECKED : BST_UNCHECKED);
	//eWombat [SNAFU][TPT]
	m_iSnafu.SetCheck(thePrefs.GetAntiSnafu());
	m_iAntiCreditTheft.SetCheck(thePrefs.GetAntiCreditTheft());
	m_iAntiFriendshare.SetCheck(thePrefs.GetAntiFriendshare());
	//eWombat [SNAFU][TPT]

	//LOG FILTERS --------------------------------------------------------
	// Maella -Filter verbose messages-
	m_filterVerboseCheck01.SetCheck((thePrefs.GetBlockUploadEndMsg() == true) ? BST_CHECKED : BST_UNCHECKED);
	m_filterVerboseCheck01.EnableWindow((thePrefs.GetVerbose() == false) ? FALSE : TRUE);	
	m_filterVerboseCheck05.SetCheck((thePrefs.GetBlockFilteredIPSourceMsg() == true) ? BST_CHECKED : BST_UNCHECKED);
	m_filterVerboseCheck05.EnableWindow((thePrefs.GetVerbose() == false) ? FALSE : TRUE);
	m_filterVerboseCheck06.SetCheck((thePrefs.GetBlockFilteredIPServerMsg() == true) ? BST_CHECKED : BST_UNCHECKED);
	m_filterVerboseCheck06.EnableWindow((thePrefs.GetVerbose() == false) ? FALSE : TRUE);
	m_filterVerboseCheck07.SetCheck((thePrefs.GetBlockMaellaSpecificMsg() == true) ? BST_CHECKED : BST_UNCHECKED);
	m_filterVerboseCheck07.EnableWindow((thePrefs.GetVerbose() == false) ? FALSE : TRUE);
	m_filterVerboseCheck08.SetCheck((thePrefs.GetBlockMaellaSpecificDebugMsg() == true) ? BST_CHECKED : BST_UNCHECKED);
	m_filterVerboseCheck08.EnableWindow((thePrefs.GetVerbose() == false) ? FALSE : TRUE);
	// [TPT] - Filter own messages
	m_filterVerboseCheck09.SetCheck((thePrefs.GetBlockPhoenixMsg() == true) ? BST_CHECKED : BST_UNCHECKED);
	m_filterVerboseCheck09.EnableWindow((thePrefs.GetVerbose() == false) ? FALSE : TRUE);
	// [TPT] - Filter Handshake messages
	m_filterVerboseCheck10.SetCheck((thePrefs.GetBlockHandshakeMsg() == true) ? BST_CHECKED : BST_UNCHECKED);
	m_filterVerboseCheck10.EnableWindow((thePrefs.GetVerbose() == false) ? FALSE : TRUE);

	//----------------------------------------------------------------END-

}

BOOL CPPgPhoenix1::OnApply()
{	
	//--------------------------------------------------------------BEGIN-

	//CONEXION -----------------------------------------------------------
	// Maella -Overhead compensation (pseudo full rate control)-
	thePrefs.SetCompensateOverhead(m_compOverheadCheck.GetCheck() != BST_UNCHECKED);

	// Maella -MTU Configuration-
	{
		CString buffer;
		m_MTUEdit.GetWindowText(buffer);
		int MTU = _tstoi(buffer);
		if(MTU > 1500) MTU = 1500;
		if(MTU < 250) MTU = 250;
		thePrefs.SetMTU(MTU);
	}
	// Maella -New bandwidth control-
	{
		CString buffer;
		m_sndSocketSizeEdit.GetWindowText(buffer);
		int sendSocketBufferSize = _tstoi(buffer);
		if(sendSocketBufferSize > 8192) sendSocketBufferSize = 8192;
		if(sendSocketBufferSize < MINIMUM_SEND_BUFFER_SIZE) sendSocketBufferSize = MINIMUM_SEND_BUFFER_SIZE;
		thePrefs.SetSendSocketBufferSize(sendSocketBufferSize);
	}
	// [TPT] - quick start
	thePrefs.m_QuickStart = m_iQuickStart.GetCheck();
	if (m_iQuickStart.GetCheck() == BST_CHECKED)
	{
		CString buffer;
		m_iMaxConn.GetWindowText(buffer);
		int maxConn = _tstoi(buffer);
		thePrefs.SetQuickStartMaxCon(maxConn);
		m_iMaxConnPerFive.GetWindowText(buffer);
		maxConn = _tstoi(buffer);
		thePrefs.SetQuickStartMaxConPerFive(maxConn);
	}
	// [TPT] - quick start


	//SUBIDAS ------------------------------------------------------------
	// Maella -Network Adapter Feedback Control-
	thePrefs.SetNAFCEnable(m_NAFCCheck01.GetCheck() == BST_CHECKED);
	thePrefs.SetNAFCFullControl(m_NAFCCheck02.GetCheck() == BST_CHECKED);
	if(m_NAFCCheck01.GetCheck() == BST_CHECKED){
		CString buffer;
		m_NAFCEdit.GetWindowText(buffer);
		double networkOut = _tstof(buffer);
		thePrefs.SetNAFCNetworkOut(networkOut);
	}
	// Maella -Minimum Upload Slot-
	{
		CString buffer;
		m_minSlotEdit.GetWindowText(buffer);
		int minUploadSlot = _tstoi(buffer);
		if(minUploadSlot > 4) minUploadSlot = 4;
		if(minUploadSlot < 2) minUploadSlot = 2;
		thePrefs.SetMinUploadSlot(minUploadSlot);
	}
	//new upload slot sharping
    thePrefs.SetEnableNewUSS(m_newUploadSlotSharpingCheck.GetCheck() != BST_UNCHECKED);
	//[TPT]-Cumulate Bandwidth
	thePrefs.SetCumulateBandwidth(m_iCumulateBW.GetCheck() != BST_UNCHECKED);

	//SERVIDOR -----------------------------------------------------------
	// Maella -Enable/Disable source exchange in preference- (Tarod)
	thePrefs.SetDisabledXS(m_XSCheck.GetCheck() != BST_UNCHECKED);

	// Maella -Reask sources after IP change- (idea Xman)
	thePrefs.SetReaskSourceAfterIPChange(m_reaskSourceAfterIPChangeCheck.GetCheck() == BST_UNCHECKED); // [TPT]

	//SEGURIDAD ----------------------------------------------------------
	// Maella -Defeat 0-filled Part Senders- (Idea of xrmb)
	thePrefs.SetCorruptionTest(m_corruptionCheck.GetCheck() != BST_UNCHECKED);
	thePrefs.SetSkipCorruptionCDTest(m_skipCorruptionCDCheck.GetCheck() != BST_UNCHECKED);
	//eWombat [SNAFU][TPT]
	thePrefs.SetEnableSnafu(m_iSnafu.GetCheck() != BST_UNCHECKED);
	thePrefs.SetEnableACT(m_iAntiCreditTheft.GetCheck() != BST_UNCHECKED);
	thePrefs.SetEnableAntiFriendshare(m_iAntiFriendshare.GetCheck() != BST_UNCHECKED);
	//eWombat [SNAFU][TPT]


	//LOG FILTERS --------------------------------------------------------
	// Maella -Filter verbose messages-
	thePrefs.SetBlockUploadEndMsg(m_filterVerboseCheck01.GetCheck() != BST_UNCHECKED);		
	thePrefs.SetBlockFilteredIPSourceMsg(m_filterVerboseCheck05.GetCheck() != BST_UNCHECKED);
	thePrefs.SetBlockFilteredIPServerMsg(m_filterVerboseCheck06.GetCheck() != BST_UNCHECKED);
	thePrefs.SetBlockMaellaSpecificMsg(m_filterVerboseCheck07.GetCheck() != BST_UNCHECKED);
	thePrefs.SetBlockMaellaSpecificDebugMsg(m_filterVerboseCheck08.GetCheck() != BST_UNCHECKED);
	thePrefs.SetBlockPhoenixMsg(m_filterVerboseCheck09.GetCheck() != BST_UNCHECKED); // [TPT] - Filter own messages
	thePrefs.SetBlockHandshakeMsg(m_filterVerboseCheck10.GetCheck() != BST_UNCHECKED); // [TPT] - Filter Handshake messages

	//----------------------------------------------------------------END-


	// Refresh Setting
	LoadSettings();
	SetModified(FALSE);	

	return CPropertyPage::OnApply();
}

void CPPgPhoenix1::Localize(void)
{	
	if(m_hWnd)
	{
		// Create an icon list for the tab control
		m_imageList.DeleteImageList();
		m_imageList.Create(16,16,theApp.m_iDfltImageListColorFlags|ILC_MASK,0,1);
		m_imageList.SetBkColor(CLR_NONE);
		m_imageList.Add(CTempIconLoader("PREF_CONNECTION"));//Imagen Conexion
		m_imageList.Add(CTempIconLoader("upload"));//Imagen Subidas
		m_imageList.Add(CTempIconLoader("PREF_SERVER"));//Imagen Servidor
		m_imageList.Add(CTempIconLoader("PREF_SECURITY"));//Imagen Seguridad
		m_imageList.Add(CTempIconLoader("myinfo"));//Imagen Filtros

		CString Buffer;
		SetWindowText(_T("pHoeniX One"));		

		int row = m_tabCtr.GetRowCount();
		InitTab(); // To update string, could be improved
		if(row != 0 && row != m_tabCtr.GetRowCount()){
			// Shift all windows object
			// .. to do
		}

	//CONEXION -----------------------------------------------------------
		m_compOverheadCheck.SetWindowText(GetResString(IDS_PPG_MAELLA_COMPENSATEOVERHEAD));
		m_MTUStatic.SetWindowText(GetResString(IDS_PPG_MAELLA_MTU_STATIC));
		Buffer.Format(GetResString(IDS_PPG_MAELLA_SND_SOCKET_SIZE_STATIC), MINIMUM_SEND_BUFFER_SIZE);
		m_sndSocketSizeStatic.SetWindowText(Buffer);
		// [TPT] - quick start		
		m_iQuickStart.SetWindowText(GetResString(IDS_ENABLEQUICKSTART)); 
		m_iMaxConnStatic.SetWindowText(GetResString(IDS_QUICK_START_MAX_CONN));
		m_iMaxConnPerFiveStatic.SetWindowText(GetResString(IDS_QUICK_START_MAX_CONN_PER_FIVE));
		m_QuickGroupBox.SetWindowText(GetResString(IDS_QUICK_START));
		// [TPT] - quick start
		
	//SUBIDAS ------------------------------------------------------------
		m_minSlotStatic.SetWindowText(GetResString(IDS_PPG_MAELLA_MIN_SLOT_STATIC));
		m_NAFCGroupBox.SetWindowText(GetResString(IDS_PPG_MAELLA_NAFC_STATIC01));
		m_NAFCStatic.SetWindowText(GetResString(IDS_PPG_MAELLA_NAFC_STATIC02));
		m_NAFCCheck01.SetWindowText(GetResString(IDS_PPG_MAELLA_NAFC_CHECK01));
		m_NAFCCheck02.SetWindowText(GetResString(IDS_PPG_MAELLA_NAFC_CHECK02));
		m_iCumulateBW.SetWindowText(GetResString(IDS_PPG_PHOENIX_CUMULATEBW));
        m_newUploadSlotSharpingCheck.SetWindowText(GetResString(IDS_PPG_MAELLA_NUSS_CHECK01));

	//SERVIDOR -----------------------------------------------------------
		m_XSCheck.SetWindowText(GetResString(IDS_PPG_MAELLA_XS_CHECK));
		m_reaskSourceAfterIPChangeCheck.SetWindowText(GetResString(IDS_PPG_MAELLA_REASK_SOURCE_AFTER_IP_CHANGE_CHECK));

	//SEGURIDAD ----------------------------------------------------------
		m_corruptionGroupBox.SetWindowText(GetResString(IDS_PPG_MAELLA_CORRUPTION_STATIC));
		m_corruptionCheck.SetWindowText(GetResString(IDS_PPG_MAELLA_CORRUPTION_CHECK));
		m_skipCorruptionCDCheck.SetWindowText(GetResString(IDS_PPG_MAELLA_SKIP_CORRUPTION_CD_CHECK));
		
		m_userHashStatic.SetWindowText(GetResString(IDS_CD_UHASH));
		m_userHashEdit.SetWindowText(EncodeBase16((const unsigned char*)thePrefs.GetUserHash(), 16));

		//eWombat [SNAFU][TPT]
		m_SnafuGroupBox.SetWindowText(GetResString(IDS_PPG_SNAFUGROUP));
		m_iSnafu.SetWindowText(GetResString(IDS_PPG_PHOENIX_SNAFU));
		m_iAntiCreditTheft.SetWindowText(GetResString(IDS_PPG_PHOENIX_ACT));
		m_iAntiFriendshare.SetWindowText(GetResString(IDS_PPG_PHOENIX_FRIENDSHARE));
		//eWombat [SNAFU][TPT]

	//LOG FILTERS --------------------------------------------------------
		m_filterVerboseGroupbox.SetWindowText(GetResString(IDS_PPG_MAELLA_FILTER_STATIC) + GetResString(IDS_VERBOSE));
		m_filterVerboseCheck01.SetWindowText(GetResString(IDS_PPG_MAELLA_FILTER_CHECK01));
		m_filterVerboseCheck05.SetWindowText(GetResString(IDS_PPG_MAELLA_FILTER_CHECK05));
		m_filterVerboseCheck06.SetWindowText(GetResString(IDS_PPG_MAELLA_FILTER_CHECK06));
		m_filterVerboseCheck07.SetWindowText(GetResString(IDS_PPG_MAELLA_FILTER_CHECK07));
		m_filterVerboseCheck08.SetWindowText(GetResString(IDS_PPG_MAELLA_FILTER_CHECK08));
		m_filterVerboseCheck09.SetWindowText(GetResString(IDS_PPG_MAELLA_FILTER_CHECK09)); // [TPT] - Filter own messages
		m_filterVerboseCheck10.SetWindowText(GetResString(IDS_PPG_MAELLA_FILTER_CHECK10)); // [TPT] - Filter Handshake messages
	}
}

void CPPgPhoenix1::InitTab(){
	// Clear all to be sure
	m_tabCtr.DeleteAllItems();
	
	// Change style
	// Remark: It seems that the multi-row can not be activated with the properties
	m_tabCtr.ModifyStyle(0, TCS_MULTILINE);

	// Add all items with icon (connection, tweak, etc...)
	m_tabCtr.SetImageList(&m_imageList);
	m_tabCtr.InsertItem(TCIF_TEXT | TCIF_IMAGE | TCIF_PARAM, CONNECTION, GetResString(IDS_PW_CONNECTION), 0, (LPARAM)CONNECTION); 	
	m_tabCtr.InsertItem(TCIF_TEXT | TCIF_IMAGE | TCIF_PARAM, UPLOAD, GetResString(IDS_TW_UPLOADS), 1, (LPARAM)UPLOAD); 	
	m_tabCtr.InsertItem(TCIF_TEXT | TCIF_IMAGE | TCIF_PARAM, SERVER, GetResString(IDS_PW_SERVER), 2, (LPARAM)SERVER); 		
	m_tabCtr.InsertItem(TCIF_TEXT | TCIF_IMAGE | TCIF_PARAM, SECURITY, GetResString(IDS_SECURITY), 3, (LPARAM)SECURITY); 	
	m_tabCtr.InsertItem(TCIF_TEXT | TCIF_IMAGE | TCIF_PARAM, LOGFILTER, GetResString(IDS_LOGFILTER), 4, (LPARAM)LOGFILTER); 				
	
}


void CPPgPhoenix1::InitControl(){
	// Remark: don't use the dialog editor => avoid to merge rc

	// Retrieve the bottom of the tab's header
	RECT rect1;
	RECT rect2;
	m_tabCtr.GetWindowRect(&rect1);
	ScreenToClient(&rect1);
	m_tabCtr.GetItemRect(m_tabCtr.GetItemCount() - 1 , &rect2);
	const int top = rect1.top + (rect2.bottom - rect2.top + 1) * m_tabCtr.GetRowCount() + 10;
	const int right = rect1.left + 10;
	const int bottom = rect1.bottom;
	

	//CONEXION -----------------------------------------------------------
		// Maella -Overhead compensation (pseudo full rate control)-
		m_compOverheadCheck.CreateEx(0, _T("BUTTON"), "", 
									 WS_CHILD /*| WS_VISIBLE*/ | WS_TABSTOP |
									 BS_AUTOCHECKBOX, 
									 CRect(right, top+20, right+300, top+20+20), this, IDC_PPG_MAELLA_COMPENSATEOVERHEAD);
		m_compOverheadCheck.SetFont(GetFont());

		// Maella -MTU Configuration-
		m_MTUEdit.CreateEx(WS_EX_CLIENTEDGE, _T("EDIT"), "", 
						WS_CHILD /*| WS_VISIBLE*/ | WS_TABSTOP | WS_BORDER |
						ES_RIGHT | ES_AUTOHSCROLL | ES_NUMBER, 
						CRect(right, top+20+30, right+40, top+20+30+20), this, IDC_PPG_MAELLA_MTU_EDIT);
		m_MTUEdit.SetFont(GetFont());
		m_MTUEdit.SetLimitText(4);

		m_MTUStatic.CreateEx(0, _T("STATIC"), "", 
							WS_CHILD /*| WS_VISIBLE*/, 
							CRect(right+45, top+20+30+3, right+45+260, top+20+30+3+20), this, IDC_PPG_MAELLA_MTU_STATIC);
		m_MTUStatic.SetFont(GetFont());

		// Maella -Send Socket Size-
		m_sndSocketSizeEdit.CreateEx(WS_EX_CLIENTEDGE, _T("EDIT"), "", 
							WS_CHILD /*| WS_VISIBLE*/ | WS_TABSTOP | WS_BORDER |
							ES_RIGHT | ES_AUTOHSCROLL | ES_NUMBER, 
							CRect(right, top+80, right+40, top+80+20), this, IDC_PPG_MAELLA_SND_SOCKET_SIZE_EDIT);
		m_sndSocketSizeEdit.SetFont(GetFont());
		m_sndSocketSizeEdit.SetLimitText(4);

		m_sndSocketSizeStatic.CreateEx(0, _T("STATIC"), "", 
								WS_CHILD /*| WS_VISIBLE*/, 
								CRect(right+45, top+80-3, right+45+260, top+80+3+20), this, IDC_PPG_MAELLA_SND_SOCKET_SIZE_STATIC);
		m_sndSocketSizeStatic.SetFont(GetFont());

		// [TPT] - quick start
		m_QuickGroupBox.CreateEx(0, _T("BUTTON"), "", 
							   WS_CHILD /*| WS_VISIBLE*/ | WS_TABSTOP |
							   BS_GROUPBOX,
							   CRect(right, top+120, right+300, top+230), this, IDC_QUICKBOX);
		m_QuickGroupBox.SetFont(GetFont());

		m_iQuickStart.CreateEx(0, _T("BUTTON"), "", 
										WS_CHILD /*| WS_VISIBLE*/ | WS_TABSTOP |
										BS_AUTOCHECKBOX, 
										CRect(right+10, top+140, right+295, top+140+20), this, IDC_PPG_PHOENIX_QUICKSTART);
		m_iQuickStart.SetFont(GetFont());

		m_iMaxConnPerFive.CreateEx(WS_EX_CLIENTEDGE, _T("EDIT"), "", 
							WS_CHILD /*| WS_VISIBLE*/ | WS_TABSTOP | WS_BORDER |
							ES_RIGHT | ES_AUTOHSCROLL | ES_NUMBER, 
							CRect(right+10, top+170, right+50, top+170+20), this,  IDC_PPG_PHOENIX_QUICKSTART_CONN_PER_FIVE);
		m_iMaxConnPerFive.SetFont(GetFont());
		m_iMaxConnPerFive.SetLimitText(4);
		m_iMaxConnPerFiveStatic.CreateEx(0, _T("STATIC"), "", 
								WS_CHILD /*| WS_VISIBLE*/, 
								CRect(right+55, top+172, right+55+230, top+172+20), this, IDC_PPG_PHOENIX_QUICKSTART_CONN_PER_FIVE_STATIC);
		m_iMaxConnPerFiveStatic.SetFont(GetFont());

		m_iMaxConn.CreateEx(WS_EX_CLIENTEDGE, _T("EDIT"), "", 
							WS_CHILD /*| WS_VISIBLE*/ | WS_TABSTOP | WS_BORDER |
							ES_RIGHT | ES_AUTOHSCROLL | ES_NUMBER, 
							CRect(right+10, top+200, right+50, top+200+20), this,  IDC_PPG_PHOENIX_QUICKSTART_CONN);
		m_iMaxConn.SetFont(GetFont());
		m_iMaxConn.SetLimitText(4);
		m_iMaxConnStatic.CreateEx(0, _T("STATIC"), "", 
								WS_CHILD /*| WS_VISIBLE*/, 
								CRect(right+55, top+202, right+55+230, top+202+20), this, IDC_PPG_PHOENIX_QUICKSTART_CONN_STATIC);
		m_iMaxConnStatic.SetFont(GetFont());


	// [TPT] - quick start

	//SUBIDAS ------------------------------------------------------------

		//NAFC
		m_NAFCGroupBox.CreateEx(0, _T("BUTTON"), "", 
							   WS_CHILD /*| WS_VISIBLE*/ | WS_TABSTOP |
							   BS_GROUPBOX,
							   CRect(right, top+20, right+300, top+20+75), this, IDC_PPG_MAELLA_NAFC_STATIC01);
		m_NAFCGroupBox.SetFont(GetFont());

		m_NAFCCheck01.CreateEx(0, _T("BUTTON"), "", 
							  WS_CHILD /*| WS_VISIBLE*/ | WS_TABSTOP |
							  BS_AUTOCHECKBOX, 
							  CRect(right+10, top+20+20, right+295, top+20+20+20), this, IDC_PPG_MAELLA_NAFC_CHECK01);
		m_NAFCCheck01.SetFont(GetFont());

		m_NAFCEdit.CreateEx(WS_EX_CLIENTEDGE, _T("EDIT"), "", 
							WS_CHILD /*| WS_VISIBLE*/ | WS_TABSTOP | WS_BORDER |
							ES_RIGHT | ES_AUTOHSCROLL, 
  							CRect(right+10, top+20+3+40, right+10+45, top+20+3+40+20), this, IDC_PPG_MAELLA_NAFC_EDIT);
		m_NAFCEdit.SetFont(GetFont());
		m_sndSocketSizeEdit.SetLimitText(5);

		m_NAFCStatic.CreateEx(0, _T("STATIC"), "", 
							  WS_CHILD /*| WS_VISIBLE*/,  
							  CRect(right+10+40+10, top+20+6+40, right+175, top+20+6+40+20), this, IDC_PPG_MAELLA_NAFC_STATIC02);
		m_NAFCStatic.SetFont(GetFont());

		m_NAFCCheck02.CreateEx(0, _T("BUTTON"), "", 
							  WS_CHILD /*| WS_VISIBLE*/ | WS_TABSTOP |
							  BS_AUTOCHECKBOX, 
							  CRect(right+10+175, top+20+3+40, right+295, top+20+3+40+20), this, IDC_PPG_MAELLA_NAFC_CHECK02);
		m_NAFCCheck02.SetFont(GetFont());
		// Maella -Minimum Upload Slot-
		m_minSlotEdit.CreateEx(WS_EX_CLIENTEDGE, _T("EDIT"), "", 
							WS_CHILD /*| WS_VISIBLE*/ | WS_TABSTOP | WS_BORDER |
							ES_RIGHT | ES_AUTOHSCROLL | ES_NUMBER, 
							CRect(right, top+115, right+40, top+115+20), this, IDC_PPG_MAELLA_MIN_SLOT_EDIT);
		m_minSlotEdit.SetFont(GetFont());
		m_minSlotEdit.SetLimitText(1);

		m_minSlotStatic.CreateEx(0, _T("STATIC"), "", 
								WS_CHILD /*| WS_VISIBLE*/, 
								CRect(right+45, top+115+3, right+45+260, top+115+3+20), this, IDC_PPG_MAELLA_MIN_SLOT_STATIC);
		m_minSlotStatic.SetFont(GetFont());

		//Maella New Upload Slot Sharping
		m_newUploadSlotSharpingCheck.CreateEx(0, _T("BUTTON"), "", 
						                      WS_CHILD /*| WS_VISIBLE*/ | WS_TABSTOP |
						                      BS_AUTOCHECKBOX, 
						                      CRect(right, top+145, right+300, top+145+20), this, IDC_PPG_MAELLA_NUSS_CHECK01);
		m_newUploadSlotSharpingCheck.SetFont(GetFont());

		//[TPT] - Cumulate Bandwidth
		m_iCumulateBW.CreateEx(0, _T("BUTTON"), "", 
						                      WS_CHILD /*| WS_VISIBLE*/ | WS_TABSTOP |
						                      BS_AUTOCHECKBOX, 
						                      CRect(right, top+165, right+300, top+165+20), this, IDC_PPG_PHOENIX_CUMULATEBW);
		m_iCumulateBW.SetFont(GetFont());

	//SERVIDOR -----------------------------------------------------------
		// Maella -Enable/Disable source exchange in preference- (Tarod)
		m_XSCheck.CreateEx(0, _T("BUTTON"), "", 
						WS_CHILD /*| WS_VISIBLE*/ | WS_TABSTOP |
						BS_AUTOCHECKBOX, 
						CRect(right, top+40, right+300, top+40+20), this, IDC_PPG_MAELLA_XS_CHECK);
		m_XSCheck.SetFont(GetFont());

		m_reaskSourceAfterIPChangeCheck.CreateEx(0, _T("BUTTON"), "", 
												 WS_CHILD /*| WS_VISIBLE*/ | WS_TABSTOP |
												 BS_AUTOCHECKBOX, 
												 CRect(right, top+40+20, right+300, top+40+20+20), this, IDC_PPG_MAELLA_REASK_SOURCE_AFTER_IP_CHANGE_CHECK);
		m_reaskSourceAfterIPChangeCheck.SetFont(GetFont());

	//SEGURIDAD ----------------------------------------------------------
		// Maella -Defeat 0-filled Part Senders- (Idea of xrmb)
		m_corruptionGroupBox.CreateEx(0, _T("BUTTON"), "", 
									  WS_CHILD /*| WS_VISIBLE*/ | WS_TABSTOP |
									  BS_GROUPBOX,
									  CRect(right, top+20, right+300, top+20+70), this, IDC_PPG_MAELLA_CORRUPTION_STATIC);
		m_corruptionGroupBox.SetFont(GetFont());

		m_corruptionCheck.CreateEx(0, _T("BUTTON"), "", 
								   WS_CHILD /*| WS_VISIBLE*/ | WS_TABSTOP |
								   BS_AUTOCHECKBOX, 
								   CRect(right+10, top+20+20, right+10+280, top+20+20+20), this, IDC_PPG_MAELLA_CORRUPTION_CHECK);
		m_corruptionCheck.SetFont(GetFont());

		m_skipCorruptionCDCheck.CreateEx(0, _T("BUTTON"), "", 
										 WS_CHILD /*| WS_VISIBLE*/ | WS_TABSTOP |
										 BS_AUTOCHECKBOX, 
										 CRect(right+10+10, top+20+40, right+10+10+270, top+20+40+20), this, IDC_PPG_MAELLA_SKIP_CORRUPTION_CD_CHECK);
		m_skipCorruptionCDCheck.SetFont(GetFont());

		//eWombat [SNAFU][TPT]
		m_SnafuGroupBox.CreateEx(0, _T("BUTTON"), "", 
									WS_CHILD /*| WS_VISIBLE*/ | WS_TABSTOP |
									BS_GROUPBOX,
									CRect(right, top+20+90, right+300, top+20+90+90), this, IDC_PPG_SNAFU);
		m_SnafuGroupBox.SetFont(GetFont());

		m_iSnafu.CreateEx(0, _T("BUTTON"), "", 
									 WS_CHILD /*| WS_VISIBLE*/ | WS_TABSTOP |
									 BS_AUTOCHECKBOX, 
									 CRect(right+10, top+20+90+20, right+295, top+20+90+20+20), this, IDC_PPG_PHOENIX_SNAFU_CHECK);
		m_iSnafu.SetFont(GetFont());
		m_iAntiCreditTheft.CreateEx(0, _T("BUTTON"), "", 
									 WS_CHILD /*| WS_VISIBLE*/ | WS_TABSTOP |
									 BS_AUTOCHECKBOX, 
									 CRect(right+10, top+20+90+40, right+295, top+20+90+40+20), this, IDC_PPG_PHOENIX_ACT_CHECK);
		m_iAntiCreditTheft.SetFont(GetFont());
		m_iAntiFriendshare.CreateEx(0, _T("BUTTON"), "", 
									 WS_CHILD /*| WS_VISIBLE*/ | WS_TABSTOP |
									 BS_AUTOCHECKBOX, 
									 CRect(right+10, top+20+90+60, right+295, top+20+90+60+20), this, IDC_PPG_PHOENIX_FRIENDSHARE_CHECK);
		m_iAntiFriendshare.SetFont(GetFont());
		//eWombat [SNAFU][TPT] END

		m_userHashStatic.CreateEx(0, _T("STATIC"), "", 
								  WS_CHILD /*| WS_VISIBLE*/,
								  CRect(right, bottom-75, right+80, bottom-35), this, IDC_PPG_MAELLA_USERHASH_STATIC);
		m_userHashStatic.SetFont(GetFont());

		m_userHashEdit.CreateEx(0, _T("EDIT"), "", 
								WS_CHILD /*| WS_VISIBLE*/ | WS_TABSTOP |
								ES_LEFT | ES_AUTOHSCROLL | ES_READONLY , 
								CRect(right+85, bottom-70, right+295, bottom-35), this, IDC_PPG_MAELLA_USERHASH_EDIT);
		m_userHashEdit.SetFont(GetFont());
	//LOG FILTERS --------------------------------------------------------
		// Maella -Filter verbose messages-
		m_filterVerboseGroupbox.CreateEx(0, _T("BUTTON"), "", 
										WS_CHILD /*| WS_VISIBLE*/ | WS_TABSTOP |
										BS_GROUPBOX,
										CRect(right, top+20, right+300, top+20+170), this, IDC_PPG_MAELLA_FILTER_STATIC);
		m_filterVerboseGroupbox.SetFont(GetFont());

		m_filterVerboseCheck01.CreateEx(0, _T("BUTTON"), "", 
										WS_CHILD /*| WS_VISIBLE*/ | WS_TABSTOP |
										BS_AUTOCHECKBOX, 
										CRect(right+10, top+20+20, right+295, top+20+20+20), this, IDC_PPG_MAELLA_FILTER_VERBOSE_CHECK01);
		m_filterVerboseCheck01.SetFont(GetFont());

		m_filterVerboseCheck05.CreateEx(0, _T("BUTTON"), "", 
										WS_CHILD /*| WS_VISIBLE*/ | WS_TABSTOP |
										BS_AUTOCHECKBOX, 
										CRect(right+10, top+20+40, right+295, top+20+40+20), this, IDC_PPG_MAELLA_FILTER_VERBOSE_CHECK05);
		m_filterVerboseCheck05.SetFont(GetFont());

		m_filterVerboseCheck06.CreateEx(0, _T("BUTTON"), "", 
										WS_CHILD /*| WS_VISIBLE*/ | WS_TABSTOP |
										BS_AUTOCHECKBOX, 
										CRect(right+10, top+20+60, right+295, top+20+60+20), this, IDC_PPG_MAELLA_FILTER_VERBOSE_CHECK06);
		m_filterVerboseCheck06.SetFont(GetFont());

		m_filterVerboseCheck07.CreateEx(0, _T("BUTTON"), "", 
										WS_CHILD /*| WS_VISIBLE*/ | WS_TABSTOP |
										BS_AUTOCHECKBOX, 
										CRect(right+10, top+20+80, right+295, top+20+80+20), this, IDC_PPG_MAELLA_FILTER_VERBOSE_CHECK07);
		m_filterVerboseCheck07.SetFont(GetFont());

		m_filterVerboseCheck08.CreateEx(0, _T("BUTTON"), "", 
										WS_CHILD /*| WS_VISIBLE*/ | WS_TABSTOP |
										BS_AUTOCHECKBOX, 
										CRect(right+10, top+20+100, right+295, top+20+100+20), this, IDC_PPG_MAELLA_FILTER_VERBOSE_CHECK08);
		m_filterVerboseCheck08.SetFont(GetFont());

		// [TPT] - Filter own messages
		m_filterVerboseCheck09.CreateEx(0, _T("BUTTON"), "", 
										WS_CHILD /*| WS_VISIBLE*/ | WS_TABSTOP |
										BS_AUTOCHECKBOX, 
										CRect(right+10, top+20+120, right+295, top+20+120+20), this, IDC_PPG_MAELLA_FILTER_VERBOSE_CHECK09);
		m_filterVerboseCheck09.SetFont(GetFont());

		// [TPT] - Filter Handshake messages
		m_filterVerboseCheck10.CreateEx(0, _T("BUTTON"), "", 
										WS_CHILD /*| WS_VISIBLE*/ | WS_TABSTOP |
										BS_AUTOCHECKBOX, 
										CRect(right+10, top+20+140, right+295, top+20+140+20), this, IDC_PPG_MAELLA_FILTER_VERBOSE_CHECK10);
		m_filterVerboseCheck10.SetFont(GetFont());

}

void CPPgPhoenix1::OnTabSelectionChange(NMHDR *pNMHDR, LRESULT *pResult)
{
	// Retrieve tab to display
	TCITEM tabCtrlItem; 
	tabCtrlItem.mask = TCIF_PARAM;
	if(m_tabCtr.GetItem(m_tabCtr.GetCurSel(), &tabCtrlItem) == TRUE){
		SetTab(static_cast<eTab>(tabCtrlItem.lParam));
	}

	*pResult = 0;
}


void CPPgPhoenix1::SetTab(eTab tab){
	if(m_currentTab != tab){
		// Hide all control
		switch(m_currentTab){
			case CONNECTION:
				m_compOverheadCheck.ShowWindow(SW_HIDE);
				m_compOverheadCheck.EnableWindow(FALSE);
				m_MTUEdit.ShowWindow(SW_HIDE);
				m_MTUEdit.EnableWindow(FALSE);
				m_MTUStatic.ShowWindow(SW_HIDE);
				m_MTUStatic.EnableWindow(FALSE);
				m_sndSocketSizeEdit.ShowWindow(SW_HIDE);
				m_sndSocketSizeEdit.EnableWindow(FALSE);
				m_sndSocketSizeStatic.ShowWindow(SW_HIDE);
				m_sndSocketSizeStatic.EnableWindow(FALSE);
				// [TPT] - quick start
				m_iQuickStart.ShowWindow(SW_HIDE);
				m_iQuickStart.EnableWindow(FALSE);
				m_iMaxConnPerFive.ShowWindow(SW_HIDE);
				m_iMaxConnPerFive.EnableWindow(FALSE);
				m_iMaxConnPerFiveStatic.ShowWindow(SW_HIDE);
				m_iMaxConnPerFiveStatic.EnableWindow(FALSE);
				m_iMaxConn.ShowWindow(SW_HIDE);
				m_iMaxConn.EnableWindow(FALSE);
				m_iMaxConnStatic.ShowWindow(SW_HIDE);
				m_iMaxConnStatic.EnableWindow(FALSE);
				m_QuickGroupBox.ShowWindow(SW_HIDE);
				m_QuickGroupBox.EnableWindow(FALSE);
				break;		
			case UPLOAD:
				m_NAFCGroupBox.ShowWindow(SW_HIDE);
				m_NAFCGroupBox.EnableWindow(FALSE);
				m_NAFCStatic.ShowWindow(SW_HIDE);
				m_NAFCStatic.EnableWindow(FALSE);
				m_NAFCCheck01.ShowWindow(SW_HIDE);
				m_NAFCCheck01.EnableWindow(FALSE);
				m_NAFCCheck02.ShowWindow(SW_HIDE);
				m_NAFCCheck02.EnableWindow(FALSE);
				m_NAFCEdit.ShowWindow(SW_HIDE);
				m_NAFCEdit.EnableWindow(FALSE);
				m_minSlotEdit.ShowWindow(SW_HIDE);
				m_minSlotEdit.EnableWindow(FALSE);
				m_minSlotStatic.ShowWindow(SW_HIDE);
				m_minSlotStatic.EnableWindow(FALSE);

				//[TPT]-Cumulate Bandwidth
				m_iCumulateBW.ShowWindow(SW_HIDE);
				m_iCumulateBW.EnableWindow(FALSE);
				m_newUploadSlotSharpingCheck.ShowWindow(SW_HIDE);
				m_newUploadSlotSharpingCheck.EnableWindow(FALSE);
				break;
			case SERVER:
				m_XSCheck.ShowWindow(SW_HIDE);
				m_XSCheck.EnableWindow(FALSE);

				m_reaskSourceAfterIPChangeCheck.ShowWindow(SW_HIDE);
				m_reaskSourceAfterIPChangeCheck.EnableWindow(FALSE);
				break;
			case SECURITY:
				m_corruptionGroupBox.ShowWindow(SW_HIDE);
				m_corruptionGroupBox.EnableWindow(FALSE);
				m_corruptionCheck.ShowWindow(SW_HIDE);
				m_corruptionCheck.EnableWindow(FALSE);
				m_skipCorruptionCDCheck.ShowWindow(SW_HIDE);
				m_skipCorruptionCDCheck.EnableWindow(FALSE);

				//eWombat [SNAFU][TPT]
				m_SnafuGroupBox.ShowWindow(SW_HIDE);
				m_SnafuGroupBox.EnableWindow(FALSE);
				m_iSnafu.ShowWindow(SW_HIDE);
				m_iSnafu.EnableWindow(FALSE);
				m_iAntiCreditTheft.ShowWindow(SW_HIDE);
				m_iAntiCreditTheft.EnableWindow(FALSE);	
				m_iAntiFriendshare.ShowWindow(SW_HIDE);
				m_iAntiFriendshare.EnableWindow(FALSE);
				//eWombat [SNAFU][TPT]
				m_userHashStatic.ShowWindow(SW_HIDE);
				m_userHashStatic.EnableWindow(FALSE);
				m_userHashEdit.ShowWindow(SW_HIDE);
				m_userHashEdit.EnableWindow(FALSE);
				break;
			case LOGFILTER:
				m_filterVerboseGroupbox.ShowWindow(SW_HIDE);
				m_filterVerboseGroupbox.EnableWindow(FALSE);
				m_filterVerboseCheck01.ShowWindow(SW_HIDE);
				m_filterVerboseCheck01.EnableWindow(FALSE);								
				m_filterVerboseCheck05.ShowWindow(SW_HIDE);
				m_filterVerboseCheck05.EnableWindow(FALSE);
				m_filterVerboseCheck06.ShowWindow(SW_HIDE);
				m_filterVerboseCheck06.EnableWindow(FALSE);
				m_filterVerboseCheck07.ShowWindow(SW_HIDE);
				m_filterVerboseCheck07.EnableWindow(FALSE);
				m_filterVerboseCheck08.ShowWindow(SW_HIDE);
				m_filterVerboseCheck08.EnableWindow(FALSE);
				// [TPT] - Filter own messages
				m_filterVerboseCheck09.ShowWindow(SW_HIDE);
				m_filterVerboseCheck09.EnableWindow(FALSE);
				// [TPT] - Filter Handshake messages
				m_filterVerboseCheck10.ShowWindow(SW_HIDE);
				m_filterVerboseCheck10.EnableWindow(FALSE);
				break;
		}

		// Show new controls
		m_currentTab = tab;
		switch(m_currentTab){
			case CONNECTION:
				m_compOverheadCheck.ShowWindow(SW_SHOW);
				m_compOverheadCheck.EnableWindow(TRUE);
				m_MTUEdit.ShowWindow(SW_SHOW);
				m_MTUEdit.EnableWindow(TRUE);
				m_MTUStatic.ShowWindow(SW_SHOW);
				m_MTUStatic.EnableWindow(TRUE);
				m_sndSocketSizeEdit.ShowWindow(SW_SHOW);
				m_sndSocketSizeEdit.EnableWindow(TRUE);
				m_sndSocketSizeStatic.ShowWindow(SW_SHOW);
				m_sndSocketSizeStatic.EnableWindow(TRUE);
				// [TPT] - quick start
				m_iQuickStart.ShowWindow(SW_SHOW);
				m_iQuickStart.EnableWindow(TRUE);
				m_iMaxConnPerFive.ShowWindow(SW_SHOW);
				m_iMaxConnPerFive.EnableWindow(TRUE);
				m_iMaxConnPerFiveStatic.ShowWindow(SW_SHOW);
				m_iMaxConnPerFiveStatic.EnableWindow(TRUE);
				m_iMaxConn.ShowWindow(SW_SHOW);
				m_iMaxConn.EnableWindow(TRUE);
				m_iMaxConnStatic.ShowWindow(SW_SHOW);
				m_iMaxConnStatic.EnableWindow(TRUE);
				m_QuickGroupBox.ShowWindow(SW_SHOW);
				m_QuickGroupBox.EnableWindow(TRUE);
				break;			
			case UPLOAD:
				m_NAFCGroupBox.ShowWindow(SW_SHOW);
				m_NAFCStatic.ShowWindow(SW_SHOW);
				m_NAFCCheck01.ShowWindow(SW_SHOW);
				m_NAFCCheck02.ShowWindow(SW_SHOW);
				m_NAFCEdit.ShowWindow(SW_SHOW);
				if(theApp.pBandWidthControl->IsNAFCAvailable() == true){
					m_NAFCGroupBox.EnableWindow(TRUE);
					m_NAFCStatic.EnableWindow(TRUE);
					m_NAFCCheck01.EnableWindow(theApp.pBandWidthControl->IsNAFCAvailable() == true);
					m_NAFCCheck02.EnableWindow(m_NAFCCheck01.GetCheck() == BST_CHECKED);
					m_NAFCEdit.EnableWindow(m_NAFCCheck01.GetCheck() == BST_CHECKED);
				}
				m_minSlotEdit.ShowWindow(SW_SHOW);
				m_minSlotEdit.EnableWindow(TRUE);
				m_minSlotStatic.ShowWindow(SW_SHOW);
				m_minSlotStatic.EnableWindow(TRUE);
				//[TPT]-Cumulate Bandwidth
				m_iCumulateBW.ShowWindow(SW_SHOW);
				m_iCumulateBW.EnableWindow(TRUE);
				m_newUploadSlotSharpingCheck.ShowWindow(SW_SHOW);
				m_newUploadSlotSharpingCheck.EnableWindow(TRUE);

				break;
			case SERVER:
				m_XSCheck.ShowWindow(SW_SHOW);
				m_XSCheck.EnableWindow(TRUE);

				m_reaskSourceAfterIPChangeCheck.ShowWindow(SW_SHOW);
				m_reaskSourceAfterIPChangeCheck.EnableWindow(TRUE);				
				break;
			case SECURITY:
				m_corruptionGroupBox.ShowWindow(SW_SHOW);
				m_corruptionGroupBox.EnableWindow(TRUE);
				m_corruptionCheck.ShowWindow(SW_SHOW);
				m_corruptionCheck.EnableWindow(TRUE);
				m_skipCorruptionCDCheck.ShowWindow(SW_SHOW);
				m_skipCorruptionCDCheck.EnableWindow(m_corruptionCheck.GetCheck() != BST_UNCHECKED);

				//eWombat [SNAFU][TPT]
				m_SnafuGroupBox.ShowWindow(SW_SHOW);
				m_SnafuGroupBox.EnableWindow(TRUE);
				m_iSnafu.ShowWindow(SW_SHOW);
				m_iSnafu.EnableWindow(TRUE);
				m_iAntiCreditTheft.ShowWindow(SW_SHOW);
				m_iAntiCreditTheft.EnableWindow(TRUE);	
				m_iAntiFriendshare.ShowWindow(SW_SHOW);
				m_iAntiFriendshare.EnableWindow(TRUE);
				//eWombat [SNAFU][TPT]


				m_userHashStatic.ShowWindow(SW_SHOW);
				m_userHashStatic.EnableWindow(TRUE);
				m_userHashEdit.ShowWindow(SW_SHOW);
				m_userHashEdit.EnableWindow(TRUE);
				break;
			case LOGFILTER:
				m_filterVerboseGroupbox.ShowWindow(SW_SHOW);
				m_filterVerboseGroupbox.EnableWindow(TRUE);
				m_filterVerboseCheck01.ShowWindow(SW_SHOW);
				m_filterVerboseCheck01.EnableWindow((thePrefs.GetVerbose() == false) ? FALSE : TRUE);								
				m_filterVerboseCheck05.ShowWindow(SW_SHOW);
				m_filterVerboseCheck05.EnableWindow((thePrefs.GetVerbose() == false) ? FALSE : TRUE);
				m_filterVerboseCheck06.ShowWindow(SW_SHOW);
				m_filterVerboseCheck06.EnableWindow((thePrefs.GetVerbose() == false) ? FALSE : TRUE);
				m_filterVerboseCheck07.ShowWindow(SW_SHOW);
				m_filterVerboseCheck07.EnableWindow((thePrefs.GetVerbose() == false) ? FALSE : TRUE);
				m_filterVerboseCheck08.ShowWindow(SW_SHOW);
				m_filterVerboseCheck08.EnableWindow((thePrefs.GetVerbose() == false) ? FALSE : TRUE);
				// [TPT] - Filter own messages
				m_filterVerboseCheck09.ShowWindow(SW_SHOW);
				m_filterVerboseCheck09.EnableWindow((thePrefs.GetVerbose() == false) ? FALSE : TRUE);
				// [TPT] - Filter own messages
				m_filterVerboseCheck10.ShowWindow(SW_SHOW);
				m_filterVerboseCheck10.EnableWindow((thePrefs.GetVerbose() == false) ? FALSE : TRUE);

				break;

		}
	}
}
// [TPT] - quick start
	void CPPgPhoenix1::OnQuickStartChange(void)
{
	bool check = (m_iQuickStart.GetCheck() == BST_CHECKED);

	m_iMaxConn.EnableWindow(check);
	m_iMaxConnStatic.EnableWindow(check);				
	m_iMaxConnPerFive.EnableWindow(check);				
	m_iMaxConnPerFiveStatic.EnableWindow(check);

	SetModified(TRUE);
}
// [TPT] - quick start

void CPPgPhoenix1::OnCorruptionCheckChange(){
	// Grey "Skip test for CD-Image (e.g. .bin, .nrg)"
	m_skipCorruptionCDCheck.EnableWindow(m_corruptionCheck.GetCheck() != BST_UNCHECKED);

	SetModified(TRUE);
}

void CPPgPhoenix1::OnNAFCChange(){
	m_NAFCCheck02.EnableWindow(m_NAFCCheck01.GetCheck() == BST_CHECKED);	
	m_NAFCEdit.EnableWindow(theApp.pBandWidthControl->IsNAFCAvailable() == true && m_NAFCCheck01.GetCheck() != BST_UNCHECKED);	
	SetModified(TRUE);
}